<?php
class tx_air_table_TCEmainHook_ONLY_TYPO3_4_5_x {

	/**
	 * A TCEmain hook to expire old records and add new ones
	 *
	 * @param string $status 'new' (ignoring) or 'update'
	 * @param string $tableName
	 * @param int $recordId
	 * @param array $databaseData
	 * @return void
	 * @todo Expire unique alias cache: how to get the proper timeout value easily here?
	 */
	public function processDatamap_afterDatabaseOperations($status, $tableName, $recordId, array $databaseData) {
			// &parentRecordInfo[table]=tt_content&parentRecordInfo[id]=20
			// Если сохранение происходит в таблице sys_file_uploads
		if ($tableName == "sys_file_uploads" && isset($GLOBALS['_GET']['parentRecordInfo']) && $GLOBALS['_GET']['parentRecordInfo']['table'] == 'tt_content') {
			$tableName = $GLOBALS['_GET']['parentRecordInfo']['table'];
			$recordId = $GLOBALS['_GET']['parentRecordInfo']['id'];
		}	
		
			// Если сохранение происходит в таблице tt_content
		if ($tableName == "tt_content") {
			$row = t3lib_befunc::getRecord($tableName, $recordId , "CType,image,media");
			if ($row['CType'] == "textpic" || $row['CType'] == "image" || $row['CType'] == "uploads") {

				$fieldConf = ($row['CType'] == "uploads") ? $GLOBALS['TCA'][$tableName]['columns']['media'] : $GLOBALS['TCA'][$tableName]['columns']['image'];
				$path_uploadfolder = "/".$fieldConf['config']['uploadfolder'];
				if (substr($path_uploadfolder, -1) != "/") {
					$path_uploadfolder = $path_uploadfolder . "/"; // добавляем слэш, если его нет в конце
				}
				
				$temp = array();
				$uidList = ($row['CType'] == "uploads") ? $row['media'] : $row['image'];
				$fileListArrayInfo = $this->selectFileInfo($path_uploadfolder, explode(",",$uidList));
				foreach ($fileListArrayInfo as $k => $v) {
					$temp['imagecaption'][] = $v['description'];
					$temp['image_link'][] = $v['file_link'];
					$temp['altText'][] = $v['alternative'];
					$temp['titleText'][] = $v['title'];
					$temp['longdescURL'][] = $v['longdescURL'];
				}
				
				if (!empty($uidList)) {
					$GLOBALS['TYPO3_DB']->exec_UPDATEquery('tt_content', 'uid=' . $recordId . '',
					array(
						'imagecaption' => implode("\n", $temp['imagecaption']),
						'image_link' =>  implode("\n", $temp['image_link']),
						'altText' =>  implode("\n", $temp['altText']),
						'titleText' =>  implode("\n", $temp['titleText']),
						'longdescURL' =>  implode("\n", $temp['longdescURL']),
					));
				}
			}
		}
	}
	
		// Получить информацию о файлах
	function selectFileInfo($path, $uidList) {
		foreach ($uidList as $key => $value) {
			$IN[] = "'".md5($path . $value)."'";
			$FIND[] = md5($path . $value);
		}
		$res = $GLOBALS['TYPO3_DB']->sql_query('
			SELECT * FROM sys_file_uploads
			WHERE identifier_md5 IN ('.implode (",", $IN).')
			ORDER BY FIND_IN_SET( identifier_md5, "'.implode (",", $FIND).'" )
		');
		$rowListFile = array();
		while( $row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res)) {
			if (trim($row['title']) == null) {
				$row['title'] = "--";
			}
			$rowListFile[] = $row;
		}
		return $rowListFile;
	}

}

?>