<?php
if (!defined('TYPO3_MODE')) {
	die ('Access denied.');
}


	// Добавляем колонку - дату создания страницы
$GLOBALS['TCA']['pages']['columns']['crdate']['label'] = 'LLL:EXT:air_table/locallang_db.xml:tx_infoblock_element.crdate';
$GLOBALS['TCA']['pages']['columns']['crdate']['config'] = array ('type' => 'input', 'size' => 13, 'max' => 20, 'eval' => 'datetime', 'checkbox' => 0, 'default' => time());
		
	t3lib_extMgm::addToAllTCAtypes('pages', 'crdate', '2', 'after:nav_title');
	t3lib_extMgm::addToAllTCAtypes('pages', 'crdate', '1,5,4,199,254', 'after:title');
	# t3lib_extMgm::addToAllTCAtypes('pages', 'crdate', '', 'after:title');
	

	// Данные колонки можно редактировать только в режиме отладки
$TCA['pages']['columns']['is_siteroot']['config']['editOnlyDebugMode'] = 1;
$TCA['pages']['columns']['editlock']['config']['editOnlyDebugMode'] = 1;
$TCA['pages']['columns']['TSconfig']['config']['editOnlyDebugMode'] = 1;


	// Добавляем иконки для содержит дополнение
$tempArrayItemsModule = $TCA['pages']['columns']['module']['config']['items'];
unset($tempArrayItemsModule[0]);

$TCA['pages']['columns']['module']['config']['items'] = null;
$TCA['pages']['columns']['module']['config']['items'][] = array('-', '');
$TCA['pages']['columns']['module']['config']['items'][] = array('Дефолтовые', '--div--');
foreach ($tempArrayItemsModule as $kItemModule => $vItemModule) {
	$TCA['pages']['columns']['module']['config']['items'][] = $vItemModule;
}

$TCA['pages']['columns']['module']['config']['items'][] = array('Служебные', '--div--');
$TCA['pages']['columns']['module']['config']['items'][] = array('LLL:EXT:air_table/locallang_db.xml:tx_infoblock_all.pages-mod-new.records', 	'ibl_record', t3lib_extMgm::extRelPath($_EXTKEY).'res/folder/new-version/records.png');
$TCA['pages']['columns']['module']['config']['items'][] = array('LLL:EXT:air_table/locallang_db.xml:tx_infoblock_all.pages-mod-new.insert', 	'ibl_insert', t3lib_extMgm::extRelPath($_EXTKEY).'res/folder/new-version/insert.png');
$TCA['pages']['columns']['module']['config']['items'][] = array('LLL:EXT:air_table/locallang_db.xml:tx_infoblock_all.pages-mod-new.other', 		'ibl_other', t3lib_extMgm::extRelPath($_EXTKEY).'res/folder/new-version/other.png');
$TCA['pages']['columns']['module']['config']['items'][] = array('LLL:EXT:air_table/locallang_db.xml:tx_infoblock_all.pages-mod-new.special', 	'ibl_specl', t3lib_extMgm::extRelPath($_EXTKEY).'res/folder/new-version/special.png');
$TCA['pages']['columns']['module']['config']['items'][] = array('LLL:EXT:air_table/locallang_db.xml:tx_infoblock_all.pages-mod-new.retweet', 	'ibl_menu', t3lib_extMgm::extRelPath($_EXTKEY).'res/folder/new-version/retweet_new.png');
	
t3lib_SpriteManager::addTcaTypeIcon('pages', 'contains-ibl_record', '../typo3conf/ext/air_table/res/folder/new-version/records.png');
t3lib_SpriteManager::addTcaTypeIcon('pages', 'contains-ibl_insert', '../typo3conf/ext/air_table/res/folder/new-version/insert.png');
t3lib_SpriteManager::addTcaTypeIcon('pages', 'contains-ibl_other', '../typo3conf/ext/air_table/res/folder/new-version/other.png');
t3lib_SpriteManager::addTcaTypeIcon('pages', 'contains-ibl_specl', '../typo3conf/ext/air_table/res/folder/new-version/special.png');
t3lib_SpriteManager::addTcaTypeIcon('pages', 'contains-ibl_menu', '../typo3conf/ext/air_table/res/folder/new-version/retweet_new.png');


	// Добавление спец. колонок в страницы
$TCA['pages']['columns'] += array(
	'tx_air_table_page_children_sorting' => array(
		'label' => 'Альтернативная сортировка дочерних страниц в дереве страниц',
		'exclude' => 1,
		'config' => array (
			'editOnlyDebugMode' => 1,
			'type' => 'select',
			'items' => array(
				// ASC – по возрастанию и DESC – по убыванию. 
				// array('По сортировке (по умолчанию)', 'По сортировке (по умолчанию)'),
				array('По названию ▲', 'title ASC'),
				array('По названию ▼', 'title DESC'),
				array('По дате создания ▲', 'crdate ASC'),
				array('По дате создания ▼', 'crdate DESC'),
				array('По типу документа ▲', 'doktype ASC'),
				array('По типу документа ▼', 'doktype DESC'),
				array('По идентификатору ▲', 'uid ASC'),
				array('По идентификатору ▼', 'uid DESC'),
			),
			'multiple' => 1,
			'minitems' => 0,
			'maxitems' => 5,
			'size' => 8,
		),
	),
	'tx_air_table_page_without_css_content_styled' => array(
		'label' => '[Beta] Страница без элементов контента',
		'exclude' => 1,
		'config' => array (
			'readOnly' => 1,
			'editOnlyDebugMode' => 1,
			'type' => 'check',
		),
	),
	'tx_air_table_page_module_special' => array(
		'label' => 'Использовать специальное дополнение-контейнер',
		'exclude' => 1,
		'config' => array (
			'editOnlyDebugMode' => 1,
			'type' => 'check',
		),
	),
	'tx_air_table_disable_drag_and_drop_this_page' => array(
		'label' => 'Запретить перемещение страницы',
		'exclude' => 1,
		'config' => array (
			'editOnlyDebugMode' => 1,
			'type' => 'check',
		),
	),
);

	// Из-за того что в разных версиях поменялись местами колонки на владках
if (version_compare(TYPO3_branch, '6.0', '>=')) {
	t3lib_extMgm::addToAllTCAtypes('pages', 'tx_air_table_page_children_sorting', '1,5,4,199,254', 'after:module');
	t3lib_extMgm::addToAllTCAtypes('pages', 'tx_air_table_page_without_css_content_styled', '1,5,4,199,254', 'after:tx_air_table_page_children_sorting');
	t3lib_extMgm::addToAllTCAtypes('pages', 'tx_air_table_disable_drag_and_drop_this_page', '1,5,4,199,254', 'after:tx_air_table_page_without_css_content_styled');
	t3lib_extMgm::addToAllTCAtypes('pages', 'tx_air_table_page_module_special', '1,5,4,199,254', 'after:tx_air_table_disable_drag_and_drop_this_page');
} else {
	t3lib_extMgm::addToAllTCAtypes('pages', 'tx_air_table_page_children_sorting', '1,5,4,199,254', 'after:php_tree_stop');
	t3lib_extMgm::addToAllTCAtypes('pages', 'tx_air_table_page_without_css_content_styled', '1,5,4,199,254', 'after:tx_air_table_page_children_sorting');
	t3lib_extMgm::addToAllTCAtypes('pages', 'tx_air_table_disable_drag_and_drop_this_page', '1,5,4,199,254', 'after:tx_air_table_page_without_css_content_styled');
	t3lib_extMgm::addToAllTCAtypes('pages', 'tx_air_table_page_module_special', '1,5,4,199,254', 'after:tx_air_table_disable_drag_and_drop_this_page');
}


	// Создаем таблицу для описания файлов, которые загружаются в папку uploads/
$TCA['sys_file_uploads'] = array(
	'ctrl' => array(
		
			// Для xDbMySQL (упрощенный мод локализации)
		'translations_columns' => array('title','description','file_link','alternative','longdescURL'),

		// Lang
		'transOrigPointerField' => 'l18n_parent',
		'transOrigDiffSourceField' => 'l18n_diffsource',
		'languageField' => 'sys_language_uid',
		
		'title' => 'Описание к загружаемому файлу (папка uploads/)',
		'label' => 'name',
		'tstamp' => 'tstamp',
		'crdate' => 'crdate',
		'cruser_id' => 'cruser_id',
		'type' => 'type',
		'hideTable' => TRUE,
		'rootLevel' => TRUE,
		# 'versioningWS' => TRUE,
		# 'origUid' => 't3_origuid',
		
		'iconfile' => t3lib_extMgm::extRelPath($_EXTKEY).'res/sys_file_uploads.png',
		'default_sortby' => 'ORDER BY crdate DESC',
		'dividers2tabs' => TRUE,
		'enablecolumns' => array(
			'disabled' => 'hidden',
		),
	),
	'columns' => array(
		'fileinfo' => array(
			'config' => array(
				#'type' => 'user',
				#'userFunc' => 'typo3/sysext/core/Classes/Resource/Hook/FileInfoHook.php:TYPO3\CMS\Core\Resource\Hook\FileInfoHook->renderFileInfo'
				'type' => 'user',
				'userFunc' => 'EXT:air_table/hooks/class.tx_air_table_dbfileicons_fal_edit_icon_Field_fileinfo.php:tx_air_table_dbfileicons_fal_edit_icon_Field_fileinfo->Field_fileinfo',
			)
		),
		'identifier' => array(
			'exclude' => 0,
			'label' => 'Идентификатор',
			'config' => array(
				'type' => 'input',
			)
		),
		'identifier_md5' => array(
			'exclude' => 0,
			'label' => 'Идентификатор (md5)',
			'config' => array(
				'type' => 'input',
			)
		),
		'extension' => array(
			'exclude' => 0,
			'label' => 'Расширение файла',
			'config' => array(
				'type' => 'input',
			)
		),
		'mime_type' => array(
			'exclude' => 0,
			'label' => 'Mime-тип файла',
			'config' => array(
				'type' => 'input',
			)
		),
		'size' => array(
			'exclude' => 0,
			'label' => 'Размер файла',
			'config' => array(
				'type' => 'input',
			)
		),
		'name' => array(
			'exclude' => 0,
			'label' => 'Имя файла',
			'config' => array(
				'type' => 'input',
				'size' => '30',
				'eval' => 'required',
				'readOnly' => TRUE
			)
		),
		'title' => array(
			'exclude' => 1,
			'label' => 'Название [titleText]',
			'config' => array(
				'type' => 'input',
				'size' => '30',
				'placeholder' => '__row|name'
			)
		),
		'description' => array(
			'exclude' => 0,
			'label' => 'Описание [imagecaption]',
			'config' => array(
				'type' => 'text',
				'cols' => '40',
				'rows' => '3'
			)
		),
		'alternative' => array(
			'exclude' => 0,
			'label' => 'Альтернативный текст [altText]',
			'config' => array(
				'type' => 'text',
				'cols' => '40',
				'rows' => '3'
			)
		),
		
		
			/*
			
			    [image_link] => Array
					(
						[exclude] => 1
						[label] => LLL:EXT:cms/locallang_ttc.xml:image_link
						[config] => Array
							(
								[type] => text
								[cols] => 30
								[rows] => 3
								[wizards] => Array
									(
										[_PADDING] => 2
										[link] => Array
											(
												[type] => popup
												[title] => LLL:EXT:cms/locallang_ttc.xml:image_link_formlabel
												[icon] => link_popup.gif
												[script] => browse_links.php?mode=wizard
												[JSopenParams] => height=300,width=500,status=0,menubar=0,scrollbars=1
											)

									)

								[softref] => typolink[linkList]
							)

					)
					
			    [longdescURL] => Array
					(
						[exclude] => 1
						[label] => LLL:EXT:cms/locallang_ttc.xml:image_longdescURL
						[config] => Array
							(
								[type] => text
								[cols] => 30
								[rows] => 3
								[wizards] => Array
									(
										[_PADDING] => 2
										[link] => Array
											(
												[type] => popup
												[title] => LLL:EXT:cms/locallang_ttc.xml:image_link_formlabel
												[icon] => link_popup.gif
												[script] => browse_links.php?mode=wizard
												[params] => Array
													(
														[blindLinkOptions] => folder,file,mail,spec
														[blindLinkFields] => target,title,class,params
													)

												[JSopenParams] => height=300,width=500,status=0,menubar=0,scrollbars=1
											)

									)

								[softref] => typolink[linkList]
							)

					)

			*/
		
		
		'file_link' => array(
						'exclude' => 1,
						'label' => 'Ссылка [image_link]',
						'config' => Array (
								'type' => 'input',
								'size' => 48,
								'max' => 255,
								'wizards' => Array (
										'_PADDING' => 2,
										'link' => Array (
												'type' => 'popup',
												'title' => 'LLL:EXT:cms/locallang_ttc.xml:image_link_formlabel',
												'icon' => 'link_popup.gif',
												'script' => 'browse_links.php?mode=wizard',
												'params' => Array (
													// 'blindLinkOptions' => 'folder,file,mail,spec',
													'blindLinkFields' => 'target,title,class,params'
												),
												'JSopenParams' => 'height=300,width=500,status=0,menubar=0,scrollbars=1',
											)
									),
								'softref' => "typolink'linkList'"
							)
		),
		'longdescURL' => array(
							'exclude' => 0,
							'label' => 'Подробный адрес [longdescURL]',
							'config' => Array (
								'type' => 'input',
								'size' => 48,
								'max' => 255,
								'wizards' => Array (
										'_PADDING' => 2,
										'link' => Array (
												'type' => 'popup',
												'title' => 'LLL:EXT:cms/locallang_ttc.xml:image_link_formlabel',
												'icon' => 'link_popup.gif',
												'script' => 'browse_links.php?mode=wizard',
												'params' => Array (
													// 'blindLinkOptions' => 'folder,file,mail,spec',
													'blindLinkFields' => 'target,title,class,params'
												),
												'JSopenParams' => 'height=300,width=500,status=0,menubar=0,scrollbars=1',
											)
									),
								'softref' => "typolink'linkList'"
							)
		),
		
		// Lang
		'sys_language_uid' => 
		array (
		  'label' => 'LLL:EXT:lang/locallang_general.php:LGL.language',
		  'config' => 
		  array (
			'readOnly' => 1,
			'type' => 'select',
			'foreign_table' => 'sys_language',
			'foreign_table_where' => 'ORDER BY sys_language.title',
			'items' => 
			array (
			  0 => 
			  array (
				0 => 'LLL:EXT:lang/locallang_general.php:LGL.allLanguages',
				1 => -1,
			  ),
			  1 => 
			  array (
				0 => 'LLL:EXT:lang/locallang_general.php:LGL.default_value',
				1 => 0,
			  ),
			),
		  ),
		),
		'l18n_parent' => 
		array (
		  'displayCond' => 'FIELD:sys_language_uid:>:0',
		  'label' => 'LLL:EXT:lang/locallang_general.php:LGL.l18n_parent',
		  'config' => 
		  array (
			'type' => 'select',
			'items' => 
			array (
			  0 => 
			  array (
				0 => '',
				1 => 0,
			  ),
			),
			'foreign_table' => 'tx_web_localization',
			'foreign_table_where' => 'AND tx_web_localization.uid=###REC_FIELD_l18n_parent### AND tx_web_localization.sys_language_uid IN (-1,0)',
		  ),
		),
		'l18n_diffsource' => 
		array (
		  'config' => 
		  array (
			'type' => 'passthrough',
		  ),
		),
		
	),
	'types' => array(
		'1' => array('showitem' => 'fileinfo, name, title, description, file_link, crdate, hidden, --div--;Дополнительно, fileinfo, alternative, longdescURL, sys_language_uid')
	),
);
$TCA['sys_file_uploads']['columns']['crdate'] = $GLOBALS['TCA']['tt_content']['columns']['starttime'];
$TCA['sys_file_uploads']['columns']['crdate']['label'] = 'Дата загрузки';
$TCA['sys_file_uploads']['columns']['hidden'] = $GLOBALS['TCA']['sys_template']['columns']['hidden'];	
$TCA['sys_file_uploads']['columns']['hidden']['label'] = 'Выключен';
t3lib_extMgm::addUserTSConfig('

	# Блокируем ненужные кнопки для "sys_file_uploads"
	options.saveDocNew.sys_file_uploads = 0
	options.disableDelete.sys_file_uploads = 1

');

		// Для TYPO3 старых версий добавляем редактирование альтернативного FAL 
	if (version_compare(TYPO3_branch, '6.0', '<')) {
		$_air_table_conf = @unserialize($GLOBALS['TYPO3_CONF_VARS']['EXT']['extConf']['air_table']);
		if ($_air_table_conf['alternativeCTypeDescription'] == 1) {
			
				// Блокируем клонки описания изображения и файлов
			$TCA['tt_content']['columns']['titleText']['config']['readOnly'] = 1;
			$TCA['tt_content']['columns']['imagecaption']['config']['readOnly'] = 1;
			$TCA['tt_content']['columns']['altText']['config']['readOnly'] = 1;
			$TCA['tt_content']['columns']['image_link']['config']['readOnly'] = 1;
			$TCA['tt_content']['columns']['longdescURL']['config']['readOnly'] = 1;
			
				// Убираем show_thumbs
			$TCA['pages']['columns']['media']['config']['show_thumbs'] = 0;
			$TCA['tt_content']['columns']['image']['config']['show_thumbs'] = 0;
			$TCA['tt_content']['columns']['media']['config']['show_thumbs'] = 0;
			
				// Выводим иконку редактирования для файлов
			$TCA['pages']['columns']['media']['config']['falEditIconEnable'] = 1;
			$TCA['tt_content']['columns']['image']['config']['falEditIconEnable'] = 1;
			$TCA['tt_content']['columns']['media']['config']['falEditIconEnable'] = 1;
			
				// Добавляем hook что бы описание из таблицы sys_file_uploads подставлялось в tt_content
			$TYPO3_CONF_VARS['SC_OPTIONS']['t3lib/class.t3lib_tcemain.php']['processDatamapClass'][] 
			= 'EXT:air_table/hooks/class.tx_air_table_TCEmainHook.ONLY.TYPO3.4.5.x.php:&tx_air_table_TCEmainHook_ONLY_TYPO3_4_5_x';
		
		} else {
			
				// Не выводим иконку редактирования для файлов
			# $TCA['pages']['columns']['media']['config']['falEditIconEnable'] = 0;
			# $TCA['tt_content']['columns']['image']['config']['falEditIconEnable'] = 0;
			# $TCA['tt_content']['columns']['media']['config']['falEditIconEnable'] = 0;
			
		}
	}


	// TCA для накопителей
if (TYPO3_MODE == 'BE') {

	$TCA['tx_air_elements'] = array (
		'ctrl' => array (
			
			'hideTable' => true,
			'is_static' => true,
			'title'     => 'LLL:EXT:air_table/locallang_db.xml:tx_air_elements',		
			'label'     => 'title',	
		
			'cruser_id' => 'cruser_id',
			'default_sortby' => 'ORDER BY sorting',	
			'sortby' => 'sorting', //Стрелочки вверх / вниз
			'rootLevel' => -1, //записи могут сущестовать как с PID=0 (корень сайта) так в в любом месте сайта страниц
			'type' => 'type_element',
			
			/* 'enablecolumns' => array (		
				//'disabled' => 'hidden',
				//'starttime'	=> 'starttime',    
				//'endtime' => 'endtime', 
				//'fe_group' => 'fe_group',
			), */
			
			//'dynamicConfigFile' => t3lib_extMgm::extPath($_EXTKEY).'tca.php',
			'iconfile'          => t3lib_extMgm::extRelPath($_EXTKEY).'res/tx_air_elements.png',
			
			//Настройка различных иконок в зависимости от тима
			'typeicon_column' => 'type_element',
			'typeicons' => array (
			
				// Папка
				'root-directory' 	=> t3lib_extMgm::extRelPath($_EXTKEY).'res/folderopened_yellow.png',


				// Стандартные
				'new-infoblock-standart-default'   		=> t3lib_extMgm::extRelPath($_EXTKEY).'res/v3/NEW-TABLE.png',
				'new-infoblock-standart-settings'  		=> t3lib_extMgm::extRelPath($_EXTKEY).'res/v3/NEW-TABLE-PROJECT-SETTINGS.png',
				'new-infoblock-standart-fal'  			=> t3lib_extMgm::extRelPath($_EXTKEY).'res/icon_tx_infoblock_table-fal.png',
				'new-infoblock-standart-se'  			=> t3lib_extMgm::extRelPath($_EXTKEY).'res/icon_tx_infoblock_table-se.png',
				'new-infoblock-property-def'  			=> t3lib_extMgm::extRelPath($_EXTKEY).'res/icon_tx_infoblock_property-def.png',
				'new-infoblock-property-standart'  		=> t3lib_extMgm::extRelPath($_EXTKEY).'res/icon_tx_infoblock_property.gif',
				'new-infoblock-property-tab' 		 	=> t3lib_extMgm::extRelPath($_EXTKEY).'res/icon_tx_infoblock_tab.png',
				'new-infoblock-property-discharged'  	=> t3lib_extMgm::extRelPath($_EXTKEY).'res/icon_tx_infoblock_discharged.png',
				'new-infoblock-property-flex'  			=> t3lib_extMgm::extRelPath($_EXTKEY).'res/icon_tx_infoblock_dynamics.gif',
				'new-infoblock-property-flex-ds'  		=> t3lib_extMgm::extRelPath($_EXTKEY).'res/icon_tx_infoblock_dynamics-ds.png',
				
				
				'new-infoblock-palette'  				=> t3lib_extMgm::extRelPath($_EXTKEY).'res/icon_tx_infoblock_palettes.png',
				'new-infoblock-palette-linebreak'  		=> t3lib_extMgm::extRelPath($_EXTKEY).'res/icon_tx_infoblock_palette-linebreak.png',
				'new-infoblock-structure'  				=> t3lib_extMgm::extRelPath($_EXTKEY).'res/icon_tx_infoblock_structure.gif',
				'new-infoblock-structure-empty'  		=> t3lib_extMgm::extRelPath($_EXTKEY).'res/icon_tx_infoblock_structure-empty.png',
				'new-infoblock-type'  					=> t3lib_extMgm::extRelPath($_EXTKEY).'res/icon_tx_infoblock_type.gif',
				'new-infoblock-type-without-children'  	=> t3lib_extMgm::extRelPath($_EXTKEY).'res/icon_tx_infoblock_type_withoutchildren.png',
				
				
				// Модификации
				'new-infoblock-modification-pages'		=> t3lib_extMgm::extRelPath($_EXTKEY).'res/v3/NEW-PAGE-DOKTYPE.png',
				'new-infoblock-modification-tt_content'	=> t3lib_extMgm::extRelPath($_EXTKEY).'res/v3/NEW-CONTENT-ELEMENT.png',
				'new-infoblock-modification'			=> t3lib_extMgm::extRelPath($_EXTKEY).'res/icon_tx_infoblock_table-modification.png',
				'new-infoblock-modification-sys_file'	=> t3lib_extMgm::extRelPath($_EXTKEY).'res/icon_tx_infoblock_table-modification-sys_file.png',
				'new-infoblock-modif-func'				=> t3lib_extMgm::extRelPath($_EXTKEY).'res/icon_tx_infoblock_table_func.png',
				'new-infoblock-structure-separator'		=> t3lib_extMgm::extRelPath($_EXTKEY).'res/icon_tx_infoblock_structure-separator.png',
				'new-infoblock-structure-pickup'  		=> t3lib_extMgm::extRelPath($_EXTKEY).'res/icon_tx_infoblock_structure-pickup.png',
				'new-infoblock-structure-onTpl'  		=> t3lib_extMgm::extRelPath($_EXTKEY).'res/icon_tx_infoblock_structure-onTpl.png',
				
				
				// Служебные
				'new-infoblock-system'				=> t3lib_extMgm::extRelPath($_EXTKEY).'res/icon_tx_infoblock_table-system.png',
				//'infoblock-system-default'		=> t3lib_extMgm::extRelPath($_EXTKEY).'res/icon_tx_infoblock_table-modification-all.png',
				//'infoblock-system-for-caching'	=> t3lib_extMgm::extRelPath($_EXTKEY).'res/icon_tx_infoblock_table-modification-all.png',
				
				
				// Добавлений колонок
				'new-add-columns'					=> t3lib_extMgm::extRelPath($_EXTKEY).'res/v3/ADD-COLUMN.png',
				
				
					// Другое 
					'ioptions' 		=> t3lib_extMgm::extRelPath($_EXTKEY).'res/icon_tx_infoblock_ioptions.png',
					'domain-model' 	=> t3lib_extMgm::extRelPath($_EXTKEY).'res/server.png',
				
			),
			
		),
		
		'columns' => array (
				'title' => array (		
					'exclude' => 0,				
					'config' => array (
						'type' => 'input',	
						'size' => '42',	
						'max' => '255',	
						'eval' => 'required',
					)
				),
		)
			
	);
}

















###############################################################
###############################################################
###################							###################
###################		Hook				###################
###################		в режиме отладки	###################
###################		выводятся назва.	###################
###################		колонок под полями	###################
###################							###################
###############################################################
###############################################################

	// так и не получается его сделать...
# $TYPO3_CONF_VARS['SC_OPTIONS']['t3lib/class.t3lib_tceforms.php']['getSingleFieldClass'][] 
# =  'EXT:air_table/hooks/class.tx_sftesthooks.php:tx_sftesthooks';


###############################################################
###############################################################
###################							###################
###################		TCA-созд.инфоб.		###################
###################		созд.пользоват.		###################
###################		включение заготовк  ###################
###################		массива				###################
###################							###################
###############################################################
###############################################################

//Включаем скомпилированные массивы tca с инфоблоками в массив TCA typo3
//Что бы избавиться от подключения перешли на файл  -  который создается через компилятор...
include (PATH_site . 'typo3temp/tx_air_table_temp/data-value/ext_tables.infoblock.registry.php');	// забираем мсассив  ($registrationTCAbasevalue)...
	
if (count ($registrationTCAbasevalue['standart']) > 0) {

	asort($registrationTCAbasevalue['standart']); // сортируем массив

	#print "<pre>";
	#print_r($registrationTCAbasevalue);
	#exit();
	
	foreach ($registrationTCAbasevalue['standart'] as $number => $ardamp)
	{
			//Защита от создания с пустыми ключами TCA и пустго массива
			if (strlen (trim( $ardamp['table_key'] )) > 0):
			
			// забираем мсассив подготовленных TCA...
			include (PATH_site . 'typo3temp/tx_air_table_temp/tca-'.trim($ardamp['table_key']).'.php');


			if (TYPO3_MODE == 'BE') {
					// Параметры внутренней работы:
				//$TCA[ $ardamp['table_key'] ]['ctrl']['rootLevel'] = -1;
				//$TCA[ $ardamp['table_key'] ]['ctrl']['rootLevel'] = 0; //записи могут сущестовать как с PID=0 (корень сайта) так в в любом месте сайта страниц
				if(isset($ardamp['ioptions']['allowTableOnStandardPages'])) {
						// Добавляем возможность вставки записи таблиц на страницах во всех местах дерева (это нужно для модификаций-инфоблоков)
					// \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::
					t3lib_extMgm::allowTableOnStandardPages( $ardamp['table_key'] );
				}
				
				if(isset($ardamp['ioptions']['addToInsertRecords'])) {
						// Добавить возможность выбора элементов инфоблока во "вставить записи"
					// \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::
					t3lib_extMgm::addToInsertRecords( $ardamp['table_key'] ); 
				}
				//третий ioptions - заблокирова из-за не возможности работы с rootLevel из-за не правильной работы foreign_table в config.type.select (если rootLevel -1 то записи не выбираются):
				//С rootlave = есть с pid = 0 есть подозрение что не правильно компилируется с pid = 0 именно 0 он разценивает его как пусто! - но пока это не подтверждилось... 
			}
		
			/*****************************//*****************************//*****************************//*****************************/
			//создаем дефолтовую колонку (title) - т.к. она нам нужна для foregeing_select 
			//и думаю что еще гденибудь да пригодится - (данная ошибка была надена в typo3 4.7.8)
			/*****************************//*****************************//*****************************//*****************************/
			// Почему-то все работает нормально!
			/* $TCA[ $ardamp['table_key'] ]['columns'] = array (
					'title' => array (	
					
						'exclude' => 0,		
						'label' => 'LLL:EXT:air_table/locallang_db.xml:tx_infoblock_structure.title',		
						'config' => array (
							'type' => 'input',	
							'size' => '42',
							'max' => '255',
							'eval' => 'required',
						)
				
				
					),
			); */
				
				//************************************************//
				//Если у нас создается конфигурационный файл:
				//Пока dynamicConfigFile - исключили (к сожалению)...
				//************************************************//
				// if ($ardamp['fe_dynamic_config_file'] == 1)
				// $TCA[ $ardamp['table_key'] ]['ctrl']['dynamicConfigFile'] = PATH_site . 'typo3temp/tx_air_table_temp/tca-dynamic-'.$ardamp['table_key'].'.php';
				
				
				
			endif;
			
	}
}



###############################################################
###############################################################
###################							###################
###################		TCA-модификация.		###################
###################		созд.пользоват.		###################
###################		включение ском.		###################
###################		массива				###################
###################							###################
###############################################################
###############################################################

/////////////////////////////////////////////////////////////////////
// 1. СОЗДАЕМ ШАБЛОН СТРУКТУРЫ АТРИБУТОВ для 'pages', 'tt_content'
// 2. СОЗДАЕМ ОРИГИНАЛ TCA для 'pages', 'tt_content', 'fe_users', 'sys_file_uploads''
/////////////////////////////////////////////////////////////////////	
$arrayTCAtemp = array ('pages', 'tt_content', 'fe_users', 'sys_file_uploads');
foreach ($arrayTCAtemp as $tablekey) {
		
		//->здесь сохраняем оригинал TCA-таблицы (нужно для сброса)
		t3lib_div::loadTCA( $tablekey );
		$GLOBALS['TCAoriginalar'][ $tablekey ] = $GLOBALS['TCA'][ $tablekey ];	
			
		
		/////////////////////////////////////////////////////////////////////
		// A) СОЗДАЕМ ШАБЛОН СТРУКТУРЫ АТРИБУТОВ для 'pages', 'tt_content'
		/////////////////////////////////////////////////////////////////////	
		if ($tablekey == "pages"){ // создаем на основе шаблона структр - "standart"
			
			// колонок никаких не удаляем
			/*
				Вставку производим перед visibility
			*/

			$string = $GLOBALS['TCA']['pages']['types'][1]['showitem'];
		
			/*
				Добавляются в конец!
			
				// Для TYPO3 6.1
			if (strstr($string, "--div--;LLL:EXT:cms/locallang_tca.xlf:pages.tabs.access")) {
				$pattern = "--div--;LLL:EXT:cms/locallang_tca.xlf:pages.tabs.access";
				$replacement = "\n###[insert]###\n--div--;LLL:EXT:cms/locallang_tca.xlf:pages.tabs.access";
			} else {
				// Для TYPO3 6.0
				$pattern = "--div--;LLL:EXT:cms/locallang_tca.xml:pages.tabs.access";
				$replacement = "\n###[insert]###\n--div--;LLL:EXT:cms/locallang_tca.xml:pages.tabs.access";
			}
			*/
			
			$GLOBALS['TCAoriginalar']['pages']['types']['default-template-structure']['showitem'] = str_replace($pattern, $replacement, $string);
			$GLOBALS['TCA']['pages']['types']['default-template-structure']['showitem'] = str_replace($pattern, $replacement, $string);
	
		} elseif ($tablekey == "tt_content"){ // создаем на основе шаблона структр - "text"
		
			// очишаем структуру от колонок bodytext, rte_enabled
			/* 
				bodytext;LLL:EXT:cms/locallang_ttc.xml:bodytext_formlabel;;richtext:rte_transform[flag=rte_enabled|mode=ts_css],
				rte_enabled;LLL:EXT:cms/locallang_ttc.xml:rte_enabled_formlabel,
					
			*/
			$string = $GLOBALS['TCA']['tt_content']['types']['text']['showitem'];
			$pattern = array( "/bodytext;([^\s]*),/is", "/rte_enabled;([^\s]*),/is", "/\t/" );
			$replacement = array( "\n###[insert]###", null , null );
			
			$GLOBALS['TCAoriginalar']['tt_content']['types']['default-template-structure']['showitem'] = preg_replace($pattern, $replacement, $string);
			$GLOBALS['TCA']['tt_content']['types']['default-template-structure']['showitem'] = preg_replace($pattern, $replacement, $string);
			
		} else {
			//
		}
			
		/////////////////////////////////////////////////////////////////////
		// B) ЗАПИСЫВАЕМ ОРИГИНАЛ TCA - !!!!!!!!! В качестве справочной информации
		/////////////////////////////////////////////////////////////////////			
		 if (!file_exists (PATH_site . 'typo3temp/tx_air_table_temp/tca-modification/tca-read-original-'.$tablekey.'.txt')) {
				
				/////////////////////////////////////////////////////////////////////
				// СОЗДАЕМ ОТДЕЛЬНУЮ ПАПКУ - что бы не путаться... TCA
				/////////////////////////////////////////////////////////////////////
				if (!file_exists (PATH_site . "typo3temp/tx_air_table_temp/tca-modification"))
				mkdir(PATH_site . "typo3temp/tx_air_table_temp/tca-modification");
							
				// Создаем оригинал TCA
				//t3lib_div::loadTCA( $ardamp['table_key'] );
			
				$handleConstant = fopen(PATH_site . 'typo3temp/tx_air_table_temp/tca-modification/tca-read-original-'.$tablekey.'.txt', 'w+');
				$arrayContent = print_r( $GLOBALS['TCA'][ $tablekey ], true );
				//$arrayContent = serialize (array ('dataValue' => $GLOBALS['TCA'][ $ardamp['table_key'] ]));
				
				// Записываем содержимое
				fwrite($handleConstant, $arrayContent); //Запись массива (в виде строки)
				fclose($handleConstant);
			
		}
	
}


/////////////////////////////////////////////////////////////////////
// 3. Подключаем отмодифицированные таблицы 'pages', 'tt_content', 'fe_users', 'sys_file_uploads'
/////////////////////////////////////////////////////////////////////	
if (count ($registrationTCAbasevalue['modification']) > 0)
foreach ($registrationTCAbasevalue['modification'] as $number => $ardamp)
{
		// Подслючаем модифицируванную готовую TCA
		// include_once
		include (PATH_site . 'typo3temp/tx_air_table_temp/tca-modification/tca-modification-'.trim($ardamp['table_key']).'.php'); // обработанный
		
		//////////////////////////////////////////
		// Работа по иконкам - старая версия
		//////////////////////////////////////////
		
			//Добвляем общий список иконок  ---------------...
			//Заполняем информацию о прикрепленных типах данных
			//Если от наз требуют альтернативное название и alternative_flag = 1
			foreach ($GLOBALS['TCA'][$ardamp['table_key']]['tempIconsForClass'] as $keyIcon => $pathIcon){
			
					//Добавляем иконку в систему
					if ($pathIcon != null) {
					
						$GLOBALS['TCA'][ $ardamp['table_key'] ]['ctrl']['typeicon_classes'][$keyIcon] = 'extensions-air_table-icon_' . $keyIcon;	
						$icons = array('icon_' . $keyIcon => '../' . $pathIcon); // PATH_site
						t3lib_SpriteManager::addSingleIcons($icons, 'air_table');
						
							#print $GLOBALS['TCA'][ $ardamp['table_key'] ]['ctrl']['typeicon_classes'][$keyIcon] . "<br />";
							#print $pathIcon . "<br />";
							#print 'icon_' . $keyIcon."<hr />";
					
					}
				
			}	
		
	
			
			
					/////////////////////////////////////////////////////////////////////	
					// Специально для таблицы pages ищем структуры помеченные, как новые
					// и добавляем их в "doktypesToShowInNewPageDragArea"
					// options.pageTree.doktypesToShowInNewPageDragArea := addToList(12)
					/////////////////////////////////////////////////////////////////////	
					if ($ardamp['table_key'] == "pages"){
						foreach ($GLOBALS['TCA']['pages']['types'] as $key => $value){
							if ($GLOBALS['TCA']['pages']['types'][$key]['doktypesToShowInNewPageDragAreaNew'] == 1){
								// $GLOBALS['PAGES_TYPES'] = // так и не понял для чего это нужно?
								# \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addUserTSConfig('
								t3lib_extMgm::addUserTSConfig('

									options.pageTree {
										doktypesToShowInNewPageDragArea := addToList('.$key.')
									}

								');
							}
						}
					}
	
					/////////////////////////////////////////////////////////////////////	
					// Специально для таблицы pages ищем структуры помеченные
					// для modules-страниц
					/////////////////////////////////////////////////////////////////////	
					if ($ardamp['table_key'] == "pages"){
						if(isset($GLOBALS['TCA']['pages']['multistructure_isNewPageModxTV'])){
							foreach ($GLOBALS['TCA']['pages']['multistructure_isNewPageModxTV'] as $key => $value){
								if (isset($value['types']['icon'])){
									t3lib_SpriteManager::addTcaTypeIcon('pages', 'contains-'.$key, $value['types']['icon']);
								}
							}
						}
					}
					
					/////////////////////////////////////////////////////////////////////	
					// Специально для таблицы tt_content ищем структуры помеченные, как новые
					// и добавляем их в "wizardItems"
					/////////////////////////////////////////////////////////////////////	
					if ($ardamp['table_key'] == "tt_content"){
						foreach ($GLOBALS['TCA']['tt_content']['types'] as $key => $value){
							if ($GLOBALS['TCA']['tt_content']['types'][$key]['cWizardNew'] == 1){
								switch($value['cWizardTabPosition']) {
								/*
								    common.show = textpic
									special.show =
									forms.show =
									plugins.show =
								*/
									default:
									case 1:
										$stringWizardItems ="
											common.show := addToList(".$key.")
											common.elements {
										";
										break;
										
									case 2:
										$stringWizardItems ="
											special.show := addToList(".$key.")
											special.elements {
										";
										break;
										
									case 3:
										$stringWizardItems ="
											forms.show := addToList(".$key.")
											forms.elements {
										";
										break;
									
									case 4:
										$stringWizardItems ="
											plugins.elements {
										";
										break;
								}
								t3lib_extMgm::addPageTSConfig('
									mod.wizards.newContentElement.wizardItems {
										# common.show := addToList('.$key.')
										# common.elements {
										'.$stringWizardItems.'
											'.$key.' {
												icon = ../../../../../../typo3conf/ext/air_table/res/user_defined.png
												title = '.$value['cWizardTitle'].'
												description = '.((trim($value['cWizardDescription']) == null) ? '-' : $value['cWizardDescription']).'
												tt_content_defValues {
													CType = '.$key.'
												}
											}
										}
									}
								');
							}
						}
					}
	
	

}
	
###############################################################
###############################################################
###################							###################
###################		TCA-созд.инфоб.		###################
###################		служеб.инфоблоков.	###################
###################		включение заготовк  ###################
###################		массива				###################
###################							###################
###############################################################
###############################################################

//Включаем скомпилированные массивы tca с инфоблоками в массив TCA typo3
if (count ($registrationTCAbasevalue['system']) > 0)
foreach ($registrationTCAbasevalue['system'] as $number => $ardamp)
{
		//Защита от создания с пустыми ключами TCA и пустго массива
		if (strlen (trim( $ardamp['table_key'] )) > 0):
	
	
			// забираем мсассив подготовленных TCA...
			include (PATH_site . 'typo3temp/tx_air_table_temp/tca-system/tca-system-'.trim($ardamp['table_key']).'.php');
		
		
		endif;
}




###############################################################
###############################################################
###################							###################
###################		TCA-созд.инфоб.		###################
###################		(часть - 2)			###################
###################		подключаем 			###################
###################		ext_tables.php из 	###################
###################		fileadmin/			###################
###############################################################
###############################################################

// Получаем путь к файлу с данными TS-настроек
#if (TYPO3_MODE == 'BE') {
	#$confArrayAirTable = unserialize($GLOBALS['TYPO3_CONF_VARS']['EXT']['extConf']['air_table']);
	#include (PATH_site.$confArrayAirTable['pathTSfile']."extTables_2.php");
	if (file_exists (PATH_site . 'typo3temp/tx_air_table_temp/extTables_2_list.php')) {
		require_once(PATH_site . 'typo3temp/tx_air_table_temp/extTables_2_list.php');
	}
#}
	


#^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^#
#^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^#
#^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^#
#^^^^^^^^^^^^^^^^^^							^^^^^^^^^^^^^^^^^^#
#^^^^^^^^^^^^^^^^^^		MOD1				^^^^^^^^^^^^^^^^^^#
#^^^^^^^^^^^^^^^^^^	 Добавление модуля 		^^^^^^^^^^^^^^^^^^#
#^^^^^^^^^^^^^^^^^^	 визуализатор		 	^^^^^^^^^^^^^^^^^^#
#^^^^^^^^^^^^^^^^^^							^^^^^^^^^^^^^^^^^^#
#^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^#
#^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^#
#^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^#
if (TYPO3_MODE == 'BE') {

	// Модели/накопители/элементы
	// Перемещяем иконку дерева (доски слеивания на 4-место, после списков...
	t3lib_extMgm::addModule('tools','txtempM2','after:config',t3lib_extMgm::extPath($_EXTKEY).'mod1/');
	
}



###############################################################
###################							###################
###################	   Что бы не писать 	###################
###################	   из проекта в проект	###################
###################		настройки для 		###################
###################		BE-пользователей	###################
###################							###################
###############################################################
###############################################################	
t3lib_extMgm::addPageTSConfig('

	# Что бы при создании новой записи выводилс новый вид wizzard
	mod.wizards.newContentElement.renderMode = tabs

');

t3lib_extMgm::addUserTSConfig('

#***********************************************************************
#	Данный конфиг содержит описание общих настроек для BE-пользователей
#***********************************************************************

	# Альтернативная цветовая гамма для модуля списков
	# mod.web_list.alternateBgColors = 1

	# Показывать дерево страниц в BE-вместе с ID-страницы
	# options.pageTree.showPageIdWithTitle = 1

	# Добавляем отображение доменных имен в дереве страниц
	# options.pageTree.showDomainNameWithTitle=1

');
	
	
###############################################################
###################							###################
###################		Маркеры				###################
###################	   Таблица с отдельным. ###################
###################	   содержимым (обычно 	###################
###################		шаблонов) 			###################
###################							###################
###############################################################
###############################################################	
$TCA['tx_air_table_marks'] = array (

	'ctrl' => array (
		
			// Для xDbMySQL (упрощенный мод локализации)
		'translations_columns' => array('string','bodytext','bodytext_with_rte','image_1','images','file_1','files','link_parameter','typoscript_code','flexform_value'),
		
		'searchFields' => 'title,string,bodytext,bodytext_with_rte,image_1,images,file_1,files,link_parameter,typoscript_code,flexform_value',
		'requestUpdate' => 'telem,rte_enabled',
		'iconfile'  => t3lib_extMgm::extRelPath($_EXTKEY).'res/icon_marks.png',
		'title'     => 'LLL:EXT:air_table/locallang_db.xml:tx_air_table_marks.title',		
		#'hideTable' => 1,
		'rootLevel' => -1,
		
		'label'     => 'title',
		'dividers2tabs' => true,
		'delete' => 'deleted', // на всякий случай
		'enablecolumns' => array (		
			//'disabled' => 'hidden',
		),
		
		// Multi type
		#'typeicon_column' => 'telem',
		'type' => 'telem',
		#'typeicons' => array (		
		#	'0' => t3lib_extMgm::extRelPath($_EXTKEY).'icon_marks_text.png', // text
		#	'file' => t3lib_extMgm::extRelPath($_EXTKEY).'icon_marks_file.png', // file
		#	'ts' => t3lib_extMgm::extRelPath($_EXTKEY).'icon_marks_ts.png', // typoscript
		#),
		
		// Lang
		'transOrigPointerField' => 'l18n_parent',
		'transOrigDiffSourceField' => 'l18n_diffsource',
		'languageField' => 'sys_language_uid',
		
	),
	
	'columns' => array (
	
		'title' => array (		
			// 'l10n_mode' => 'prefixLangTitle',
			'label'   => 'Название маркера',
			'config'  => array (	
				# 'editOnlyDebugMode' => true,
				'type'    => 'input',
				'size' => '48',
				'max' => '255'
			)
		),
		'string' => array (		
			// 'l10n_mode' => 'prefixLangTitle',
			'label'   => 'Содержимое',
			'config'  => array (
				'type'    => 'input',
				'size' => '48',
				'max' => '255'
			)
		),
		'uid' => array (		
			// 'l10n_mode' => 'prefixLangTitle',
			'label'   => 'Идентификатор',
			'config'  => array (	
				'readOnly' => 1,
				'type'    => 'input',
				'size' => '25'
			)
		),
		/*
		'key_translate' => array (		
			'displayCond' => 'FIELD:l18n_parent:=:0',
			'label'   => 'Уникальный ключ в шаблоне',
			'config'  => array (
				'readOnly' => 1,
				'type'    => 'input',
				'size' => '32',
				'max' => '255'
			)
		),
		'onlytext' => array (		
			'label'   => 'Текст перевода',
			'config'  => array (
				'type'    => 'text',
				'cols' => '38',
                'rows' => '10',
			)
		),
		*/
		'typoscript_code' => array (		
			'label'   => 'Typoscript-код',
			'config'  => array (
				'type'    => 'text',
				'cols' => '30',
                'rows' => '5',
			)
		),	
		'bodytext' => array (		
			'label'   => 'Содержимое',
			'config'  => array (
				'type'    => 'text',
				'cols' => '30',
                'rows' => '5',
			)
		),
		# 'rte_enabled' => $GLOBALS['TCA']['tt_content']['columns']['rte_enabled'],

		'bodytext_with_rte' => array (		
			'label'   => 'Содержимое',
			'defaultExtras' => 'richtext[*]',
			'config'  => array (
				'type'    => 'text',
				'cols' => '30',
                'rows' => '5',
			)
		),
		'image_1' => array (		
			'label'   => 'Содержимое', // Документ-изображение
			'config' => array (
				'type'          => 'group',
				'internal_type' => 'file',
				'allowed'       => 'jpeg, jpg, png, gif',
				'max_size'      => $GLOBALS['TYPO3_CONF_VARS']['BE']['maxFileSize'],
				'uploadfolder' 	=> 'uploads/pics/',
				'size'          => 1,
				'minitems'      => 0,
				'maxitems'      => 1,
				'show_thumbs'	=> 0,
			)
		),
		'images' => array (		
			'label'   => 'Содержимое', // Документ-изображение
			'config' => array (
				'type'          => 'group',
				'internal_type' => 'file',
				'allowed'       => 'jpeg, jpg, png, gif',
				'max_size'      => $GLOBALS['TYPO3_CONF_VARS']['BE']['maxFileSize'],
				'uploadfolder' 	=> 'uploads/pics/',
				'size'          => 10,
				'minitems'      => 0,
				'maxitems'      => 100,
				'show_thumbs'	=> 0,
			)
		),
		'file_1' => array (		
			'label'   => 'Содержимое', // Документ
			'config' => array (
				'type'          => 'group',
				'internal_type' => 'file',
				'allowed'       => '*',
				'disallowed'	=> 'php,php3',
				'max_size'      => $GLOBALS['TYPO3_CONF_VARS']['BE']['maxFileSize'],
				'uploadfolder' 	=> 'uploads/media/',
				'size'          => 1,
				'minitems'      => 0,
				'maxitems'      => 1,
				'show_thumbs'	=> 0,
			)
		),
		'files' => array (		
			'label'   => 'Содержимое', // Документ
			'config' => array (
				'type'          => 'group',
				'internal_type' => 'file',
				'allowed'       => '*',
				'disallowed'	=> 'php,php3',
				'max_size'      => $GLOBALS['TYPO3_CONF_VARS']['BE']['maxFileSize'],
				'uploadfolder' 	=> 'uploads/media/',
				'size'          => 10,
				'minitems'      => 0,
				'maxitems'      => 100,
				'show_thumbs'	=> 0,
			)
		),
		'telem' => array (		
			// 'l10n_mode' => 'prefixLangTitle',
			'label'   => 'Тип элемента',
			'config'  => array (
				# 'editOnlyDebugMode' => true,
				'type' => 'select',
				'size' => '1',
				'minitems' => '0',
				'maxitems' => '1',
				/*
				'items' => array(
					1 => array(0 => "Текст", 1=> 0), //text
					2 => array(0 => "Файл [beta]", 1=> "file"),
					3 => array(0 => "Typoscript [beta]", 1=> "ts"),
				),
				*/
				'items' => array(
					0 => array(0 => "Строка", 1=> 'string'), //string
					1 => array(0 => "Текст", 1=> 'text'), //text
					2 => array(0 => "Текст (с редактором)", 1=> 'text_with_rte'), //text with RTE
					3 => array(0 => "Изображение", 1=> "image_1"), // image_1
					4 => array(0 => "Изображения", 1=> "images"), // images
					5 => array(0 => "Документ", 1=> "file_1"), // file_1
					6 => array(0 => "Документы", 1=> "files"), // files
					7 => array(0 => "Ссылка", 1=> "link"),
					8 => array(0 => "Typoscript", 1=> "ts"),
					9 => array(0 => "Гибкие параметры", 1=> "flexform"),
				),
				'authMode' => 'explicitAllow',
				'authMode_enforce' => 'strict',
				'default' => 'text',
			)
		),
		
		'link_parameter' => Array (
						'exclude' => 1,
						'label' => 'Ссылка',
						'config' => Array (
								'type' => 'input',
								'size' => 48,
								'max' => 255,
								'wizards' => Array (
										'_PADDING' => 2,
										'link' => Array (
												'type' => 'popup',
												'title' => 'LLL:EXT:cms/locallang_ttc.xml:image_link_formlabel',
												'icon' => 'link_popup.gif',
												'script' => 'browse_links.php?mode=wizard',
												'params' => Array (
													// 'blindLinkOptions' => 'folder,file,mail,spec',
													'blindLinkFields' => 'target,title,class,params'
												),
												'JSopenParams' => 'height=300,width=500,status=0,menubar=0,scrollbars=1',
											)
									),
								'softref' => "typolink'linkList'"
							)
		),		

		'flexform_ts_config' => array(
			'label' => 'TS-настройка дополнительный свойств',
			'exclude' => 1,
			'config' => array (
				'editOnlyDebugMode' => 1,
				'type' => 'text',
				'cols' => '35',
				'rows' => '12',
			),
		),
		'flexform_ts_config_help' => array(
			'label' => 'Справка с примерами настройки',
			'exclude' => 1,
			'config' => array (
				'type' => 'user',
				'userFunc' => 'EXT:air_table/pbild/class.tx_ar_table_tca_flexform_ts_config_help.php:tx_ar_table_tca_flexform_ts_config_help->Field_flexform_ts_config_help',
			),
		),
		'flexform_value' => array(
			'label' => 'Пользовательские свойства',
			'config' => array (
				'type' => 'flex',	
				'ds' => array('default' => 'FILE:EXT:air_table/res/default-flexform.xml'), // generation avtomatik in hook
				'ds_pointerField' => 'uid',
			),
		),
		
		/*
		'markers_list' => array (		
			'displayCond' => 'FIELD:l18n_parent:<=:0',
			'label'   => 'Доступные маркеры в переводе - правка в режиме отладки',
			'config'  => array (
				'editOnlyDebugMode' => 1,
				'type' => 'text',
				'cols' => '38',
                'rows' => '15',
			)
		),
		*/
		// Lang
		'sys_language_uid' => 
		array (
		  'label' => 'LLL:EXT:lang/locallang_general.php:LGL.language',
		  'config' => 
		  array (
			'readOnly' => 1,
			'type' => 'select',
			'foreign_table' => 'sys_language',
			'foreign_table_where' => 'ORDER BY sys_language.title',
			'items' => 
			array (
			  0 => 
			  array (
				0 => 'LLL:EXT:lang/locallang_general.php:LGL.allLanguages',
				1 => -1,
			  ),
			  1 => 
			  array (
				0 => 'LLL:EXT:lang/locallang_general.php:LGL.default_value',
				1 => 0,
			  ),
			),
		  ),
		),
		'l18n_parent' => 
		array (
		  'displayCond' => 'FIELD:sys_language_uid:>:0',
		  'label' => 'LLL:EXT:lang/locallang_general.php:LGL.l18n_parent',
		  'config' => 
		  array (
			'type' => 'select',
			'items' => 
			array (
			  0 => 
			  array (
				0 => '',
				1 => 0,
			  ),
			),
			'foreign_table' => 'tx_web_localization',
			'foreign_table_where' => 'AND tx_web_localization.uid=###REC_FIELD_l18n_parent### AND tx_web_localization.sys_language_uid IN (-1,0)',
		  ),
		),
		'l18n_diffsource' => 
		array (
		  'config' => 
		  array (
			'type' => 'passthrough',
		  ),
		),
	),
	
	'types' => array (
		'text' => array('showitem' => '
			telem;;;;1-1-1,
			uid;;;;1-1-1,
			title;;;;2-2-2, 
			bodytext;;;;2-2-2, 
			rte_enabled;;;;2-2-2,
			--div--;Дополнительно,
			sys_language_uid;;;;1-1-1, 
			pelem;;;;1-1-1,
		'),
		'text_with_rte' => array('showitem' => '
			telem;;;;1-1-1,
			uid;;;;1-1-1,
			title;;;;2-2-2, 
			bodytext_with_rte;;;;2-2-2, 
			rte_enabled;;;;2-2-2,
			--div--;Дополнительно,
			sys_language_uid;;;;1-1-1, 
			pelem;;;;1-1-1,
		'),
		'string' => array('showitem' => '
			telem;;;;1-1-1,
			uid;;;;1-1-1,
			title;;;;2-2-2, 
			string;;;;2-2-2, 
			--div--;Дополнительно,
			sys_language_uid;;;;1-1-1, 
			pelem;;;;1-1-1,
		'),
		'image_1' => array('showitem' => '
			telem;;;;1-1-1, 
			uid;;;;1-1-1,
			title;;;;2-2-2,
			image_1;;;;1-1-1,
			--div--;Дополнительно,
			sys_language_uid;;;;1-1-1,
			pelem;;;;1-1-1,
		'),
		'images' => array('showitem' => '
			telem;;;;1-1-1, 
			uid;;;;1-1-1,
			title;;;;2-2-2,
			images;;;;1-1-1,
			--div--;Дополнительно,
			sys_language_uid;;;;1-1-1,
			pelem;;;;1-1-1,
		'),
		'file_1' => array('showitem' => '
			telem;;;;1-1-1, 
			uid;;;;1-1-1,
			title;;;;2-2-2,
			file_1;;;;1-1-1,
			--div--;Дополнительно,
			sys_language_uid;;;;1-1-1,
			pelem;;;;1-1-1,
		'),
		'files' => array('showitem' => '
			telem;;;;1-1-1, 
			uid;;;;1-1-1,
			title;;;;2-2-2,
			files;;;;1-1-1,
			--div--;Дополнительно,
			sys_language_uid;;;;1-1-1,
			pelem;;;;1-1-1,
		'),
		'link' => array('showitem' => '
			telem;;;;1-1-1, 
			uid;;;;1-1-1,
			title;;;;2-2-2,
			link_parameter;;;;1-1-1,
			--div--;Дополнительно,
			sys_language_uid;;;;1-1-1,
			pelem;;;;1-1-1,
		'),
		'ts' => array('showitem' => '
			telem;;;;1-1-1, 
			uid;;;;1-1-1,
			title;;;;2-2-2,
			typoscript_code;;;;1-1-1,
			--div--;Дополнительно,
			sys_language_uid;;;;1-1-1,
			pelem;;;;1-1-1,
		'),
		'flexform' => array('showitem' => '
			telem;;;;1-1-1, 
			uid;;;;1-1-1,
			title;;;;2-2-2,
			flexform_value;;;;1-1-1,
			--div--;Дополнительно,
			flexform_ts_config;;;;1-1-1,
			flexform_ts_config_help;;;;1-1-1,
			sys_language_uid;;;;1-1-1,
			pelem;;;;1-1-1,
		'),
	),
);

	// Подключаем сгенерированные Flex-формы // Open a directory, and read its contents
if (TYPO3_MODE=='BE') {
	$dir = PATH_site . "typo3temp/tx_air_table_temp/flexform_tx_air_table_marks/";
	if (file_exists ($dir)) {
		$dh  = opendir($dir);
		while (false !== ($filename = readdir($dh))) {
			$ext = substr($filename, strrpos($filename, '.') + 1);
			if(in_array($ext, array("xml"))){
				$idRecord = str_replace(".xml" , "", $filename);
				$GLOBALS['TCA']['tx_air_table_marks']['columns']['flexform_value']['config']['ds'][$idRecord] 
				= "FILE:typo3temp/tx_air_table_temp/flexform_tx_air_table_marks/" . $filename;
			}
		}
		closedir($dh);
	}
}
# $GLOBALS['TCA']['tx_air_table_marks']['columns']['rte_enabled']['config']['readOnly'] = 0;
# $GLOBALS['TCA']['tx_air_table_marks']['columns']['rte_enabled']['config']['editOnlyDebugMode'] = 1;
t3lib_extMgm::addUserTSConfig('

	# Блокируем ненужные кнопки для "sys_file_uploads"
	options.saveDocNew.tx_air_table_marks = 0
	options.disableDelete.tx_air_table_marks = 1

');
t3lib_extMgm::allowTableOnStandardPages( 'tx_air_table_marks' );

###############################################################
###################							###################
###################		Коробки				###################
###################	   с набором уник. 		###################
###################	   свойств				###################
###################							###################
###############################################################
###############################################################	
	$GLOBALS['TCA']['tt_content']['columns']['CType']['config']['items'][] = array("Коробки", "--div--");
	$GLOBALS['TCA']['tt_content']['columns']['CType']['config']['items'][] = array("Кэшируемая", "box", '../typo3conf/ext/air_table/res/icon_tt_content_box.png');
	$GLOBALS['TCA']['tt_content']['columns']['CType']['config']['items'][] = array("Не кэшируемая", "box_int", '../typo3conf/ext/air_table/res/icon_tt_content_box_int.png');
	
	$GLOBALS['TCA']['tt_content']['columns'] += array(
		'box_rendering_ts_config' => array(
			'label' => 'TS-настройка рендеринга коробки',
			'exclude' => 1,
			'config' => array (
				'editOnlyDebugMode' => 1,
				'type' => 'text',
				'cols' => '35',
				'rows' => '12',
			),
		),
		'box_rendering_ts_config_help' => array(
			'label' => 'Справка с примерами настройки рендеринга',
			'exclude' => 1,
			'config' => array (
				'type' => 'user',
				'userFunc' => 'EXT:air_table/pbild/class.tx_ar_table_tca_box_rendering_ts_config_help.php:tx_ar_table_tca_box_rendering_ts_config_help->Field_box_rendering_ts_config_help',
			),
		),
		'flexform_ts_config' => array(
			'label' => 'TS-настройка дополнительный свойств',
			'exclude' => 1,
			'config' => array (
				'editOnlyDebugMode' => 1,
				'type' => 'text',
				'cols' => '35',
				'rows' => '12',
			),
		),
		'flexform_ts_config_help' => array(
			'label' => 'Справка с примерами настройки',
			'exclude' => 1,
			'config' => array (
				'type' => 'user',
				'userFunc' => 'EXT:air_table/pbild/class.tx_ar_table_tca_flexform_ts_config_help.php:tx_ar_table_tca_flexform_ts_config_help->Field_flexform_ts_config_help',
			),
		),
		'flexform_value' => array(
			'label' => 'Пользовательские свойства',
			'config' => array (
				'type' => 'flex',	
				'ds' => array('default' => 'FILE:EXT:air_table/res/default-flexform.xml'), // generation avtomatik in hook
				'ds_pointerField' => 'uid',
			),
		),
		/*
		'box_rendering_ajax_num_regust' => array(
			'label' => 'Зарегестрировать eIdAjax-страницу (по Id данного элемента контента) - правка в режиме отладки',
			'exclude' => 1,
			'config' => array (
				'editOnlyDebugMode' => 1,
				'type' => 'check',
				'default' => '0',
			),
		),
		'box_rendering_settings' => array(
			'label' => 'Дополнительные настройки - правка в режиме отладки',
			'exclude' => 1,
			'config' => array (
				'editOnlyDebugMode' => 1,
				'type' => 'select',
				'max' => 5,
				'size' => 5,
				'maxitems' => 3,
				'items' => array (
					0 => array (0 => 'Конвертировать в НЕ кэшируемый объект, если переданы _POST-данные', 1 => 'convert2IntIfSendPost'),
					1 => array (0 => 'Конвертировать в НЕ кэшируемый объект, если третьи (белые) страницы', 1 => 'convert2IntIfWhitePage'),
					2 => array (0 => 'Конвертировать в НЕ кэшируемый объект, если авторизирован FE-пользователь', 1 => 'convert2IntIfFeUserAuthorization'),
				),
			),
		),
		*/
	);

	$GLOBALS['TCA']['tt_content']['palettes']['box_rendering_ts_config']['canNotCollapse'] = 1;
	$GLOBALS['TCA']['tt_content']['palettes']['box_rendering_ts_config']['showitem'] = "
		box_rendering_ts_config,
		box_rendering_ts_config_help
	";
	
	$GLOBALS['TCA']['tt_content']['palettes']['flexform_ts_config']['canNotCollapse'] = 1;
	$GLOBALS['TCA']['tt_content']['palettes']['flexform_ts_config']['showitem'] = "
		flexform_ts_config,
		flexform_ts_config_help
	";

	$tempStructure = $GLOBALS['TCA']['tt_content']['types']['text']['showitem'];
	$tempStructure = str_replace("bodytext;LLL:EXT:cms/locallang_ttc.xml:bodytext_formlabel;;richtext:rte_transform[flag=rte_enabled|mode=ts_css],", "", $tempStructure);
	$tempStructure = str_replace("rte_enabled;LLL:EXT:cms/locallang_ttc.xml:rte_enabled_formlabel,", "######", $tempStructure);
	$tempStructure = str_replace("######", "
	
		flexform_value;;;;1-1-1,
		
		--div--;Настройка коробки,
		--palette--;Настройка дополнительный свойств;flexform_ts_config,
		--palette--;Настройка шаблонизатора;box_rendering_ts_config,

		box_rendering_settings;;;;1-1-1,
		box_rendering_ajax_num_regust;;;;1-1-1,
	
	", $tempStructure);
	
	$GLOBALS['TCA']['tt_content']['types']['box']['showitem'] = $tempStructure;
	$GLOBALS['TCA']['tt_content']['types']['box_int']['showitem'] = $tempStructure;	
	
		// Icon
	$GLOBALS['TCA']['tt_content']['ctrl']['typeicon_classes']['box'] = 'extensions-air_table-icon_box';	
	$GLOBALS['TCA']['tt_content']['ctrl']['typeicon_classes']['box_int'] = 'extensions-air_table-icon_box_int';	
	
		$icons = array('icon_box' => t3lib_extMgm::extRelPath($_EXTKEY).'res/icon_tt_content_box.png'); // PATH_site
		t3lib_SpriteManager::addSingleIcons($icons, 'air_table');
		
		$icons = array('icon_box_int' => t3lib_extMgm::extRelPath($_EXTKEY).'res/icon_tt_content_box_int.png'); // PATH_site
		t3lib_SpriteManager::addSingleIcons($icons, 'air_table');
	
		// Wizard
	t3lib_extMgm::addPageTSConfig('
		mod.wizards.newContentElement.wizardItems {
		 plugins {
			 elements {
				 box {
					 title = Коробка - элемент контента для раздела
					 description = Вставка элемента контента с набором уникальных свойств и настройкой рендеринга
					 icon = ../typo3conf/ext/air_table/res/icon_tt_content_box_wizards.png
					 tt_content_defValues {
						CType = box
					 }
				 }
				 box_int {
					 title = Коробка - элемент контента для раздела (INT-вариант)
					 description = Вставка элемента контента с набором уникальных свойств и настройкой рендеринга
					 icon = ../typo3conf/ext/air_table/res/icon_tt_content_box_int_wizards.png
					 tt_content_defValues {
						 CType = box_int
					 }
				 }
			 }
			 # show := addToList(box,box_int)
		 }
	 }
	');
	
		// Rendering коробки
	// t3lib_extMgm::addTypoScript($_EXTKEY,'setup','',43, 1); // setupTSConfig - перенесено в ext_localconf.php
	
		// Подключаем сгенерированные Flex-формы // Open a directory, and read its contents
	if (TYPO3_MODE=='BE') {
		$dir = PATH_site . "typo3temp/tx_air_table_temp/flexform_tt_content/";
		if (file_exists ($dir)) {
			$dh  = opendir($dir);
			while (false !== ($filename = readdir($dh))) {
				$ext = substr($filename, strrpos($filename, '.') + 1);
				if(in_array($ext, array("xml"))){
					$idRecord = str_replace(".xml" , "", $filename);
					$GLOBALS['TCA']['tt_content']['columns']['flexform_value']['config']['ds'][$idRecord] 
					= "FILE:typo3temp/tx_air_table_temp/flexform_tt_content/" . $filename;
				}
			}
			closedir($dh);
		}
	}
	
###############################################################
###############################################################
###################							###################
###################	   TCA-таблиц.заметки.	###################
###################	  						###################
###############################################################
###############################################################
// if (TYPO3_MODE == 'BE') {
	$TCA['tx_air_table_user_help'] = array (
		'ctrl' => array (
			'title'     => 'LLL:EXT:air_table/locallang_db.xml:tx_air_table_user_help.title',
			'label'     => 'title',			
			'rootLevel' => 1, //записи могут сущестовать только с PID=0 (корень сайта)
			'cruser_id' => 'cruser_id',
			'delete' => 'deleted',	
			// 'sortby' => 'sorting', //Стрелочки вверх / вниз
			'dividers2tabs' => TRUE, //Включение вкладок (tabs)
			'enablecolumns' => array (		
				'disabled' => 'hidden',
			),
			'iconfile'	=> t3lib_extMgm::extRelPath($_EXTKEY).'res/icon_tx_air_table_user_help.png',
		),
		'columns' => array (
			'title' => array (		
				'exclude' => 0,		
				'label' => 'Название',		
				'config' => array (
					'type' => 'input',	
					'size' => '42',	
					'max' => '255',	
					'eval' => 'required',
				)
			),
			"bodytext" => Array (		
				"exclude" => 1,		
				"label" => "Содержимое",	
				"config" => Array (
					"type" => "text",
					"cols" => "72",
					"rows" => "32",
					'wrap' => 'OFF'
				),
				#"defaultExtras" => "richtext[cut|copy|paste|formatblock|textcolor|bold|italic|underline|left|center|right|orderedlist|unorderedlist|outdent|indent|link|table|image|line|chMode]:rte_transform[mode=ts_css|imgpath=uploads/tx_mininews/rte/]",
				"defaultExtras" => "richtext[*]",
			),
		),
		'types' => array (
			'0' => array('showitem' => 'title;;;;2-2-2,bodytext;;;;2-2-2')
		),
	);

		// Добавляем возможность вставки записи таблиц на страница
	// t3lib_extMgm::allowTableOnStandardPages('tx_air_table_user_help');
// }

###############################################################
###############################################################
###################							###################
###################	 Генерация гибких форм  ###################
###################	 при сохранении,		###################
###################	 что бы не запускать	###################
###################	 каждый раз				###################
###################	 компилятор				###################
###################							###################
###############################################################
###############################################################
 
	// Для двух таблиц (tt_content & tx_air_table_marks)
$TYPO3_CONF_VARS['SC_OPTIONS']['t3lib/class.t3lib_tcemain.php']['processDatamapClass'][] 
= 'EXT:air_table/hooks/class.tx_air_table_TCEmainHook_generationFlexForm.php:&tx_air_table_TCEmainHook_generationFlexForm';
?>