<?php
/***************************************************************
 *  Copyright notice
 *
 *  (c) 2012  <>
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

//Если мы что-то грузим по ajax
/* ВСЕ ЭТО МЫ НЕ ВЫВОДИМ ЕСЛИ РАБОТАЕТ AJAX */


/**
 * Module 'air_table' for the 'air_table' extension.
 *
 * @author	 <>
 * @package	TYPO3
 * @subpackage	tx_testtree
 */ 
//require_once(PATH_typo3conf.'ext/air_table/pbild/class.tcabild.php'); //включаем класс для создания динам.tca
require_once(PATH_t3lib . 'class.t3lib_scbase.php');
class tx_testtree_module1 extends t3lib_SCbase {
	
	protected $pageinfo;
	protected $numopenelement; //для хранения списка уникальных ключей через ";" открытых веток в дереве для текущего пользователя BE
	protected $last_news_records_add; //в данную переменную заносим недавно добавленные элементы, что бы их выделить другим цветом на досске...
	protected $countI = 0; //счетчик элементов для массива
	protected $is_lock_board; //в данную переменную пишем статус доступа к доске...
	
	/**
	 * Initializes the module.
	 *
	 * @return void
	 */
	public function init() {
		#parent::init();

		/*
		if (t3lib_div::_GP('clear_all_cache'))	{
			$this->include_once[] = PATH_t3lib . 'class.t3lib_tcemain.php';
		}
		*/
	}

	/**
	 * Main function of the module. Write the content to $this->content
	 * If you chose "web" as main module, you will need to consider the $this->id parameter which will contain the uid-number of the page clicked in the page tree
	 *
	 * @return void
	 */
	public function main() {
	
			// Access check!
			// The page will show only if there is a valid page and if this page may be viewed by the user
		$this->pageinfo = t3lib_BEfunc::readPageAccess($this->id, $this->perms_clause);
		$access = is_array($this->pageinfo) ? 1 : 0;
		
		if (($this->id && $access) || ($GLOBALS['BE_USER']->user['admin'] && !$this->id)) {
		
				// Draw the header.
			$this->doc = t3lib_div::makeInstance('bigDoc');
			$this->doc->backPath = $GLOBALS['BACK_PATH'];

				// CSS-file
			$this->doc->getPageRenderer()->addCssFile(t3lib_extMgm::extRelPath('air_table') . 'mod1/systemdir/depo.css');
			$this->doc->inDocStylesArray[] = '
							
			/* веточки */
			.joinbottom  { float: left; display: block; width: 22px; height: 20px; background: url("gfx/ol/joinbottom.gif") 4px 3px no-repeat; }
			.join { float: left; display: block; width: 22px; height: 20px; background: url("gfx/ol/join.gif") 4px 3px  no-repeat; }
			.line { float: left; display: block; width: 22px; height: 20px; background: url("gfx/ol/line.gif") 4px 3px  no-repeat; }
			.blank { float: left; display: block; width: 22px; height: 20px; background: url("gfx/ol/blank.gif") 4px 3px  no-repeat; }

			';
			
				// JavaScript
			$this->doc->loadJavascriptLib('contrib/prototype/prototype.js');
			$this->doc->loadJavascriptLib('js/common.js');
			$this->doc->JScode = '
				<script language="javascript" type="text/javascript">
					script_ended = 0;
					function jumpToUrl(URL)	{
						document.location = URL;
					}
				</script>
				<script src="'.t3lib_extMgm::extRelPath('air_table') .'mod1/systemdir/jquery-1.8.3.min.js"></script>
				<script src="'.t3lib_extMgm::extRelPath('air_table') .'mod1/systemdir/document-ready.js"></script>
				<script src="'.t3lib_extMgm::extRelPath('air_table') .'mod1/systemdir/ajax_function.js"></script>
			';
			$this->doc->postCode = '
				<script language="javascript" type="text/javascript">
					script_ended = 1;
					if (top.fsMod) top.fsMod.recentIds["web"] = 1;
				</script>
			';

				// Узнаем кол-во накопителей (всего)
			$res = $GLOBALS['TYPO3_DB']->sql_query("SELECT count(uid) AS 'countElement' FROM tx_air_elements WHERE type_element 
				IN (
				'new-infoblock-standart-default', 
				'new-infoblock-standart-settings',
				'new-infoblock-modification-pages',
				'new-infoblock-modification-tt_content',
				'new-infoblock-system',
				'new-infoblock-standart-se',
				'new-add-columns'
			)");
			$row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res);
			
				// Узнаем кол-во маркеров (всего)
			$resMarks = $GLOBALS['TYPO3_DB']->sql_query("SELECT count(uid) AS 'countElement' FROM tx_air_table_marks");
			$rowMarks = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($resMarks);
     
				// Проверяем найден ли входящий TS-файл
			$confArrayAirTable = unserialize($GLOBALS['TYPO3_CONF_VARS']['EXT']['extConf']['air_table']); // Получаем путь к файлу с данными TS-настроек
			if (file_exists(PATH_site."typo3conf/AllTSDomainModels/")){ //$confArrayAirTable['pathTSfile']);
				$file_exists = " [<span style='color: green;'><b>найдена</b></span>]";
			} else {
				$file_exists = " [<span style='color: red;'><b>не найдена</b></span>]";
			}
			
				// Ссылка на возврат (если идет просмотр таблицы)
			if (isset($GLOBALS['_GET']['browseTable']) || isset($GLOBALS['_GET']['browseDomainModel'])){
				$backlink = "<a href='/typo3/mod.php?M=tools_txtempM2'>";
				$backlink .= t3lib_iconWorks::getSpriteIcon( 'actions-view-go-back' );
				$backlink .= "</a>";
			}
			
				// В зависимости от версии TYPO3 шаблон
			if (version_compare(TYPO3_branch, '6.0', '>=')) {
				$template = file_get_contents(t3lib_extMgm::extRelPath('air_table') . 'mod1/mod_template.TYPO3.6.x+.html');
			} else {
				$template = file_get_contents(t3lib_extMgm::extRelPath('air_table') . 'mod1/mod_template.TYPO3.4.5.x+.html');
			}
			$arrMarkers['###BUTTONLIST_RIGHT###'] = 'Всего накопителей: '.intval($row['countElement']).', всего маркеров для шаблонов: '.intval($rowMarks['countElement']).' <!--| скачать дамп всех накопителей <img src="../typo3conf/ext/air_table/mod1/img/data.gif" style="padding-top: 1px;" onclick="alert(\'Beta\')">-->';
			$arrMarkers['###INFO###'] = '<b>Входящая папка со списком папок typoscript-описаний:</b> <a style="color: blue;" href="/typo3conf/AllTSDomainModels/" target="_blank">/typo3conf/AllTSDomainModels/' . $file_exists . '</a>';
			$arrMarkers['###CONTENT###'] = '
						<h2>Визуализатор моделей и накопителей</h2>
						<table border="0" cellpadding="0" cellspacing="0" class="typo3-dblist">
						<tr class="c-table-row-spacer"><td></td></tr>
						<tr class="t3-row-header">
						
							<td nowrap="nowrap">'.t3lib_iconWorks::getSpriteIcon('apps-pagetree-root').'&nbsp;'. $GLOBALS['TYPO3_CONF_VARS']['SYS']['sitename'].'</td>
							<td align="right" style="padding-right: 5px;">
								<div id="iblbloctreeevent_clear" style="height: 18px; float: right; cursor: pointer !important;">
								<div id="iblbloctreeevent_clear_wrap">
									<span class="iblFunction_check_see_def_property">
									Показать дефолтовые свойства <img src="../typo3conf/ext/air_table/mod1/icon/see_def_property.png" style="vertical-align: top;"></span>
									|
									<span href="?M=txtestM1_txtestM1&treeevent[clear]=1" class="iblFunction_check_treeevent_clear" onclick="alert(\'Beta\')">
									Версия для печати <img src="../typo3conf/ext/air_table/mod1/img/print.png" style="vertical-align: top;"></span>
								</div>
								</div>
							</td>
							
						</tr>
						<tr>
							<td colspan="2" class="modcontent" style="padding: 0; margin: 0;">
							'. $this->moduleContent($row['countElement']) .'
							</td>
						</tr>
						<tr>
							<td colspan="2" style="border-top: #d7d7d7 1px solid; background-color: #ece2bc;">
								Для создания таблицы/колонок необходимо нажать "Таблица НЕ Существует - исправить!" 
								либо "Есть не подкрепленные колонки - исправить!".
							</td>
						</tr>
						</table>
						<br /><br /><br />
			';

			$this->content .= $this->doc->startPage($GLOBALS['LANG']->getLL('title'));	
			$this->content .= str_replace(array('###BUTTONLIST_RIGHT###','###INFO###','###CONTENT###'), array($arrMarkers['###BUTTONLIST_RIGHT###'],$arrMarkers['###INFO###'],$arrMarkers['###CONTENT###']), $template);
			$this->content .= $this->doc->spacer(10);
		} else {
				// If no access or if ID == zero

			$this->doc = t3lib_div::makeInstance('bigDoc');
			$this->doc->backPath = $GLOBALS['BACK_PATH'];

			$this->content .= $this->doc->startPage($GLOBALS['LANG']->getLL('title'));
			$this->content .= $this->doc->spacer(5);
			$this->content .= $this->doc->spacer(10);
		}
	
	}

	/**
	 * Prints out the module HTML.
	 *
	 * @return void
	 */
	public function printContent() {
		
		//$this->content .= "<hr>* - данные должны быть уникальными в построенном дереве склеиваний<hr>";
		$this->content .= $this->doc->endPage();
		echo $this->content;
		
	}
	
	/**
	 * Generates the module content.
	 *
	 * @return void
	 */
	function moduleContent($countElement) {
		
		if ($countElement == 0){
			return "
			<ul><li><div class='allpanelelement' style='border-left: black 3px solid; padding: 5px 5px 2px 5px;'>
			" . t3lib_iconWorks::getSpriteIcon('apps-pagetree-page-no-icon-found') . " Не найдено ни одного накопителя!
			</div></li></ul>";
		}
		
			// Если это отправка формы			
		if (isset($GLOBALS['_POST']['tx_this'])){
			return $this->moduleContentMysqlTableMaster_postQuery();
			// exit();
		}
		
			// Если это справление таблиц
		elseif ($GLOBALS['_GET']['masterTable'] == 1)
		return $this->moduleContentMysqlTableMaster();
		
			// Если это список таблиц
		else
		return $this->moduleContentListTable();
		
	}
	
	/**
	 * Generates the module content.
	 *
	 * @return void
	 */
	function moduleContentMysqlTableMaster_postQuery() {

	
			// Если это создание таблицы:
			if (isset($GLOBALS['_POST']['tx_this']['sqlTablePattenr'])){
				if ($GLOBALS['TYPO3_DB']->sql_query (stripslashes($GLOBALS['_POST']['tx_this']['sqlTablePattenr']))){
					return " <div style='background-color: #cdeacb; padding: 32px; color: #538a47;' align='center'>
							 <div style='max-width: 500px;'>
								Таблица <b>".$GLOBALS['_GET']['elementTableKey']."</b> успешна создана!<br /><br />
								<input type='button' value='К списку таблиц...' style='color: green;' onclick='window.location.href=\"/typo3/mod.php?M=tools_txtempM2\"'>
							</div>
							</div>";
				}
			}
			
			// Если это создание колонок
			elseif (isset($GLOBALS['_POST']['tx_this']['sqlColumnAdded'])){
				foreach ($GLOBALS['_POST']['tx_this']['sqlColumnAdded'] as $keyMysqlColumn => $valueMysqlColumn){
					if ($GLOBALS['TYPO3_DB']->sql_query ( "ALTER TABLE `".$GLOBALS['_GET']['elementTableKey']."` ADD `".$keyMysqlColumn."`" . $valueMysqlColumn )){
						$listComplateCreateColumns[] = $keyMysqlColumn;
					}
				}
				if (count ($listComplateCreateColumns) > 0)
				return " <div style='background-color: #cdeacb; padding: 32px; color: #538a47;' align='center'>
						 <div style='max-width: 500px;'>
							Колонки <b>".implode(", " , $listComplateCreateColumns)."</b> для таблицы <b>".$GLOBALS['_GET']['elementTableKey']."</b> успешно созданы!<br /><br />
							<input type='button' value='К списку таблиц...' style='color: green;' onclick='window.location.href=\"/typo3/mod.php?M=tools_txtempM2\"'>
						</div>
						</div>";
				else
				return " <div style='background-color: #f6d3cf; padding: 32px; color: #fd2727;' align='center'>
						 <div style='max-width: 500px;'>
							Не выбрано колонок для создания!<br /><br />
							
							
							<input type='button' value='Обратно...' onclick='window.location.href=\"/typo3/mod.php?M=tools_txtempM2&masterTable=1&elementTableKey=".$GLOBALS['_GET']['elementTableKey']."\"'>
							<input type='button' value='К списку таблиц...' onclick='window.location.href=\"/typo3/mod.php?M=tools_txtempM2\"'>
						</div>
						</div>";
			}
			
			// Не известно
			else {}
			
			// header - обратно на список
			//header("Location: /typo3/mod.php?M=tools_txtempM2&ok=1"); 
			//exit();
		
	}
	
	/**
	 * Generates the module content.
	 *
	 * @return void
	 */
	function moduleContentMysqlTableMaster() {
		
			
			###########################################################
			// Если не существует таблицы - предлагаем ее создать...
			###########################################################
			// Проверка сущестования таблицы
			$resTable = $GLOBALS['TYPO3_DB']->sql_query("SELECT * FROM information_schema.tables WHERE TABLE_SCHEMA = '".TYPO3_db."' AND TABLE_NAME = '".$GLOBALS['_GET']['elementTableKey']."' LIMIT 1");
			$numTable = $GLOBALS['TYPO3_DB']->sql_num_rows($resTable);
			if ($numTable <= 0){
				
				// Если ключ таблицы существует
				if (trim($GLOBALS['_GET']['elementTableKey']) != null){
					$pattern = file_get_contents(PATH_typo3conf . 'ext/air_table/pbild/ext_tables.pattern.sql');
					$pattern = str_replace ("tt_infoblock_elements_***", $GLOBALS['_GET']['elementTableKey'], $pattern);
					
					$content .= "<div align='center' style='padding-top: 32px; padding-bottom: 32px;'>";
					$content .= "<form method='post'><table width='100%'><tr><td align='center'>";
					$content .= "
						
								<div style='padding: 3px; background-color: #D8D8D8; width: 50%; max-width: 500px;'><b>Мастер создания новой mysql-таблицы</b></div>
								<textarea style='display: none;' 
								name='tx_this[sqlTablePattenr]'>".stripslashes($pattern)."</textarea>
								
								<textarea style='width: 50%; max-width: 500px; height: 720px;' 
								disabled>".stripslashes($pattern)."</textarea>
					
					</td></tr></table>";
					
					$content .= "<input type='submit' value='Создать таблицу' style='color: green;'>&nbsp;&nbsp;&nbsp;";
					$content .= "<input type='button' value='отмена' style='color: red;' onclick='window.location.href=\"/typo3/mod.php?M=tools_txtempM2\"'>";
					$content .= "</form>";
					$content .= "</div>";

				} else {

					$content .= "<div align='center' style='padding-top: 32px; padding-bottom: 32px;'>";
					$content .= "<form method='post'><table width='100%'><tr><td align='center'>";
					$content .= "
						
								<div style='padding: 3px; background-color: #D8D8D8; width: 50%; max-width: 500px;'><b>Мастер создания новой mysql-таблицы</b></div>
								<p style='margin: 10px;'>Создание таблицы не возможно, т.к. в настройках <br />
								TS-конфигураций не задан sql-ключ для таблицы.</p>
					
					</td></tr></table>";
					
					$content .= "<input type='button' value='отмена' style='color: red;' onclick='window.location.href=\"/typo3/mod.php?M=tools_txtempM2\"'>";
					$content .= "</form>";
					$content .= "</div>";
				
				}
				
				
			} else {
				
				###########################################################
				// Если таблица существует -, но не существуют колонки...	
				// Предлагаем создать их
				###########################################################
				t3lib_div::loadTCA($GLOBALS['_GET']['elementTableKey']);
				$columnsInTable = $GLOBALS['TCA'][$GLOBALS['_GET']['elementTableKey']]['columns'];
				$selectHTML = array (
													
														"Целые числа" => array (
															"TINYINT" => 'TINYINT',
															"INT (11)" => 'INT (11)',
															"BIGINT" => 'BIGINT',
														),
													
														"Дробные числа" => array (
															"FLOAT" => 'FLOAT',
															"DOUBLE" => 'DOUBLE',
														),
														
														"Строки" => array (
															"VARCHAR (32)" => 'VARCHAR (32)',
															"VARCHAR (128)" => 'VARCHAR (128)',
															"VARCHAR (255)" => 'VARCHAR (255)',
															"TINYTEXT" => 'TINYTEXT',
															"TEXT" => 'TEXT',
															"MEDIUMTEXT" => 'MEDIUMTEXT',
															"LONGTEXT" => 'LONGTEXT',
														),
				);
													
				
				$content .= "<div align='center' style='padding-top: 32px; padding-bottom: 32px;'>";
				$content .= "<form method='post'><table align='center'><tr><td align='center' colspan='2'>";
				$content .= "<div style='padding: 3px; background-color: #D8D8D8; width: 100%;'><b>Мастер создания колонок mysql-таблицы</b></div></td></tr>";
				
				t3lib_div::loadTCA($GLOBALS['_GET']['elementTableKey']); // загружаем TCA
				foreach ($columnsInTable as $key => $value){
					
					// Проверка колонки на валидность
					#if(!preg_match("/^[a-zA-Z_][a-zA-Z0-9_]*$/", $key)) {
					#	continue;
					#}
					
					// Проверка сущестования колонки
					$resColumns = $GLOBALS['TYPO3_DB']->sql_query("
						SELECT * FROM information_schema.COLUMNS 
						WHERE
							TABLE_SCHEMA = '".TYPO3_db."'  
							AND TABLE_NAME='".$GLOBALS['_GET']['elementTableKey']."'
							AND COLUMN_NAME='".$key."'
					");
					$numColumns = $GLOBALS['TYPO3_DB']->sql_num_rows($resColumns);
					if ($numColumns <= 0){
						
						$selected = 0;
						$content .= "<tr><td width='50%' align='left'>".$key." <span style='color: gray;'>(".$GLOBALS['TCA'][$GLOBALS['_GET']['elementTableKey']]['columns'][$key]['config']['type'].")</span></td>";
						$content .= "<td align='right'><select name='tx_this[sqlColumnAdded][".$key."]'><option value='0'>Не создавать</option>";
						foreach ($selectHTML as $grup => $opt)
						{
							$content.= '<optgroup label="'.$grup.'">';
							
								// В зависимости от типа предлагаем создать определенную колонку
							foreach ($opt as $name => $val) {
								/*
								if ($GLOBALS['TCA'][$GLOBALS['_GET']['elementTableKey']]['columns'][$key]['config']['type'] == "text" && $val == "TEXT"){
									$content.= '<option style="background-color: green; color: white;" value="'.$val.'" selected>'.$name.' (рекомендуется)</option>';
								} elseif ($GLOBALS['TCA'][$GLOBALS['_GET']['elementTableKey']]['columns'][$key]['config']['type'] == "group" && $val == "TEXT"){
									$content.= '<option style="background-color: green; color: white;" value="'.$val.'" selected>'.$name.' (рекомендуется)</option>';
								} elseif ($GLOBALS['TCA'][$GLOBALS['_GET']['elementTableKey']]['columns'][$key]['config']['type'] == "input" && $val == "VARCHAR (255)"){
									$content.= '<option style="background-color: green; color: white;" value="'.$val.'" selected>'.$name.' (рекомендуется)</option>';
								} else {
									$content.= '<option value="'.$val.'">'.$name.'</option>';
								}
								*/
									
									// INPUT
								if ($GLOBALS['TCA'][$GLOBALS['_GET']['elementTableKey']]['columns'][$key]['config']['type'] == "input" && $val == "VARCHAR (255)"){
									$content.= '<option value="'.$val.'" selected>'.$name.' (рекомендуется)</option>';
									$selected = 1;
									
									// BODYTEXT
								} elseif ($GLOBALS['TCA'][$GLOBALS['_GET']['elementTableKey']]['columns'][$key]['config']['type'] == "text" && $val == "TEXT"){
									$content.= '<option value="'.$val.'" selected>'.$name.' (рекомендуется)</option>';
									$selected = 1;
									
									// TINYTEXT
								} else {
									if ($val == "TINYTEXT" && $selected == 0) {
										$content.= '<option value="'.$val.'" selected>'.$name.' (рекомендуется)</option>';
									} else {
										$content.= '<option value="'.$val.'">'.$name.'</option>';
									}
								}
							}
							$content.= '</optgroup>';
						}
						$content .= "</select></td>";
						$content .= "</tr>";
						
					}
				}
				
				$content .= "<tr><td colspan='2'>";
				$content .= "<input type='submit' value='Создать колонки в таблице - ".$GLOBALS['_GET']['elementTableKey']."' style='color: green;'>&nbsp;&nbsp;&nbsp;";
				$content .= "<br /><br /><input type='button' value='отмена' style='color: red;' onclick='window.location.href=\"/typo3/mod.php?M=tools_txtempM2\"'>";
				$content .= "</td></tr></table>";
				$content .= "</form>";
				$content .= "</div>";
			
			}
			
		return $content;
		
	}
	
	/**
	 * Generates the module content.
	 *
	 * @return void
	 */
	function moduleContentListTable() {
		
		$content .="
		<style>
		
				/* оберточки отображающие права доступа на веточку */
				span.plashka.not { opacity: 0.25; background-color: red; }
				span.plashka.o8 { opacity: 0.8 }
				span.plashka.o7 { opacity: 0.7 }
				span.plashka.o6 { opacity: 0.6 }
				span.plashka {
					
					float: right;
					padding-left: 5px; padding-right: 5px; /* opacity: 0.8; */ font-size: 10px;
					background-color: black; color: white; border-radius: 5px;
					margin-left: 5px;
					margin-right: 6px;
					margin-top: 3px;

				}
				span.plashka.red { background-color: red; }
				span.plashka.yellow { background-color: #FF8C00; }
				span.plashka.green { background-color: green; }
				span.link:hover { background-color: blue; }
				span.link a { color: white; }
				
				div.elementTable { padding: 5px 0px 5px 6px; border-left: black 3px solid; } 
				div.elementTable:hover { background-color: #D8D8D8; }

				div.elementTableLevel_2 div.elementTable { margin-left: 7px; padding: 8px 0px 2px 6px; border-left: #eeeeee 3px solid; }  
				div.elementTableLevel_2 div.elementTable:hover { background-color: #C0C0C0; }
				div.elementTableLevel_2 span.plashka { margin-top: 0; }
				
		</style>
		";
		
			// Если идет показ таблицы
		if (isset($GLOBALS['_GET']['browseTable']) || isset($GLOBALS['_GET']['browseDomainModel'])){
			$content .= $this->browseTable();
		} else {
			$content .= $this->getElements(0);
		}
		return $content;
		
	}
	
		// Обзор таблицы
	function browseTable(){
		$content = "
			<div 
			id='boxArx'
			style='position: relative; padding: 15px; min-height: 500px; background:url(/typo3conf/ext/air_table/res/bg-fon-browse.gif); text-align: center;'>
			<canvas id='boxArxCanvas' style='border: red 0px solid; position: absolute; top: 15px; left: 15px; z-index: 1;'></canvas>
			
			
			
			<!--<div id='TABLE_RELATION_tt_beta_from' style='position: absolute; top: 200px; left: 100px; padding: 2px; '>!!</div>-->
			<!--<div id='TABLE_RELATION_tt_beta_to' style='position: absolute; top: 200px; left: 200px; padding: 2px; '>!!</div>-->
	
			
			<input class='canvasAboutRelationTable' type='hidden' 
			value='TABLE_RELATION_tt_beta.from|TABLE_RELATION_tt_beta.to'>
			
			
			<div id='boxArx_wrap' style='position: relative; z-index: 2;'>
				".$this->boxAadd_table($damp_dmodel, $resultCoordsPosition)."
				".$this->boxAadd_coords($damp_dmodel)."
			</div>
			</div>
		";
		
		return $content;
	}
	

	//функция наносит таблицы инфоблоков на коробоку
	function boxAadd_table($damp_dmodel, $coordsElements){
	
		//Получаем все таблицы, которые принадлежат данной структуре...
		preg_match_all('/tx_infoblock_table_([0-9]+)/i', $damp_dmodel['rdatamember'], $matches); 
		
		//выбиораем все данные
		#$order = " FIND_IN_SET( uid,  '".implode ("," , $matches[1])."' ) "; //этот ордер нужен для соблюдения последовательности
		#$where = " uid IN (".implode ("," , $matches[1]).") "; // AND (iblock_type = 'standart' OR iblock_type = 'system') 
		if (isset($GLOBALS['_GET']['browseDomainModel'])){
			$res = $GLOBALS['TYPO3_DB']->sql_query('SELECT * FROM tx_air_elements WHERE parent_element = "'  . $GLOBALS['_GET']['browseDomainModel'] . '"');
			$csspositionverdict = "  position: absolute; left: 300px; top: 200px;";
			$onlyIdColumnAndRelationColumn = 1;
			return false; // beta
		} else {
			$res = $GLOBALS['TYPO3_DB']->sql_query('SELECT * FROM tx_air_elements WHERE key_element = "'  . $GLOBALS['_GET']['browseTable'] . '"  LIMIT 1;');
			$csspositionverdict = "  margin: 0 auto; margin-top: 100px; margin-bottom: 100px;";
		}
		while ( ($damp = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res)) ){
			
			//Создаем переменные для хранения данных под текущий выбранны элемент...
			$temp = $result = $output_columns = $_x = $_y = $_zIndex = null;
			$matches_y = $matches_x = $matches_zIndex = null;
			
			//Иконка
			#if ($GLOBALS['TCA'][$damp['key_element']]['ctrl']['typeicon_classes']['default'] == null) 
			#$icon = "<div class='t3-icon-".$damp['key_element']."-default div16'></div>";
			#else $icon = t3lib_iconWorks::getSpriteIcon( $GLOBALS['TCA'][$damp['key_element']]['ctrl']['typeicon_classes']['default'] );
		
			//1. Выбираем все колонки:
			$columns = $GLOBALS['TYPO3_DB']->sql_query( 'SHOW COLUMNS FROM `'.$damp['key_element']."`");
			while ( ($damp_columns = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($columns)) ){
			
						
					// Если это просмотр доменной модели - выводим упрощенные вариант таблиц со связями
				if ($onlyIdColumnAndRelationColumn  == 1){
					t3lib_div::loadTCA($GLOBALS['TCA'][$damp['key_element']]);
					if (
						$damp_columns['Field'] != "uid" &&
						$GLOBALS['TCA'][$damp['key_element']]['columns'][$damp_columns['Field']]['config']['type'] != "select" &&
						$GLOBALS['TCA'][$damp['key_element']]['columns'][$damp_columns['Field']]['config']['type'] != "db" &&
						$GLOBALS['TCA'][$damp['key_element']]['columns'][$damp_columns['Field']]['config']['type'] != "inline"
					)
					continue;
					
						// Пишем связи
					$from = $damp['key_element'] . "." . $damp_columns['Field'];
					$to = $GLOBALS['TCA'][$damp['key_element']]['columns'][$damp_columns['Field']]['config']['foreign_table'] . ".uid";
					$relation = "<input class='canvasAboutRelationTable' type='' value='".$from."|".$to."'>";
			
				}
			
				$output_columns .= $relation;
				$output_columns .= "
				
				<div style='background-color: #eeeeee; text-align: left; padding: 2px; padding-top: 1px; padding-bottom: 1px;'>
					<div id='TABLE_RELATION_".$damp['key_element']."_".$damp_columns['Field']."' style='position: relative; padding: 0px; '>".$damp_columns['Field']." 
						<div style='color: gray; top: 0; position: absolute; padding: 0px; right: 0px;'>".$damp_columns['Type']."</div>
					</div>
				</div>
				<!--<td>".$damp_columns['Null']."</td>-->";
				//$output_columns .= "</tr>";
				
			}
			
			//2. Выбираем все то, что принадлежит инфоблоку (типы, стрктуры и т.д.)
			$output_temp = "
			<div style='text-align: left; padding: 5px; background-color: #ece2bc; border-bottom: gray 1px solid; border-top: gray 1px solid;'>
				Справочная информация
			</div>";
				
				//а) Количество записей в таблице
				$result_count = $GLOBALS['TYPO3_DB']->sql_query('SELECT count(uid) AS count_records FROM ' . $damp['key_element']);
				$damp_count = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($result_count);
				if ($damp_count['count_records'] == null) $damp_count['count_records'] = "-";
				
				//б) Размер таблицы
				//SHOW TABLE STATUS LIKE 'fa_stat_download'
				$result_table_size = $GLOBALS['TYPO3_DB']->sql_query( "SHOW TABLE STATUS LIKE '".$damp['key_element']."' " );  
				while( $damp_table_size = $GLOBALS['TYPO3_DB']->sql_fetch_assoc( $result_table_size ) )   
				$table_size  = $damp_table_size[ "Data_length" ] + $damp_table_size[ "Index_length" ];  
			
				//Переводим в читаемый вид 
				$table_size = $this->humanBytes($table_size);
				
				$output_temp .=	"<div style='background-color: white; padding: 5px; text-align: left;'><img src='".t3lib_extMgm::extRelPath('air_table') ."res/records.png'> Кол-во записей:	[".$damp_count['count_records']."]</div>";
				$output_temp .=	"<div style='background-color: white; padding: 5px; text-align: left;'><img src='".t3lib_extMgm::extRelPath('air_table') ."res/database_table.png'> Размер тиблицы:	[".$table_size."]</div>";
			
				//разбираем поле ресурсов
				/* preg_match_all('/tx_infoblock_([a-z]+)_([0-9]+)/i', $damp['rdata'], $matches); 
				for ($i = 0; $i < count($matches[1]); $i++){
				
					//Данные о файле...
					$tempdamp = t3lib_befunc::getRecord("tx_infoblock_".$matches[1][$i], $matches[2][$i], '*');
					$temp["tx_infoblock_".$matches[1][$i]][] = $tempdamp;
					//$icon2 = t3lib_iconWorks::getSpriteIconForRecord("tx_infoblock_".$matches[1][$i], $temp, array('class' => 'c-recIcon'));
					//$output_temp .= "<div style='padding: 3px;'>".$icon2 . " " . $temp['title'] . "</div>"; 
				}
			
				//Собираем структуры
				foreach ($temp['tx_infoblock_structure'] as $num => $val )
				$result['structure'][] = "[" . $val['uid'] . "] " . $val['title'];
				if (count($result['structure']) > 0)
				$output_temp .= "<div style='padding: 3px;'><img src='".t3lib_extMgm::extRelPath('air_table') ."res/icon_tx_infoblock_structure.gif'>
				" . implode (", " , $result['structure']) . "</div>";
				
				//Собираем типы
				foreach ($temp['tx_infoblock_type'] as $num => $val )
				$result['type'][] = "[" . $val['uid'] . "] " . $val['title'];
				if (count($result['type']) > 0)
				$output_temp .= "<div style='padding: 3px;'><img src='".t3lib_extMgm::extRelPath('air_table') ."res/icon_tx_infoblock_type.gif'>
				" . implode (", " , $result['type']);
				*/
				
				
				//выбираем типы...
				
			//$output_temp .="</td></tr>";
			//$x = mysql_num_rows($search); 
		
			
			//Определяем координаты x,y и zIndex для данной таблицы
			//$csspositionverdict = $this->returnStylePosition( $coordsElements['this.']['table.'][$damp['key_element']] );
			//$csspositionverdict = "  position: absolute; left: 300px; top: 200px;";
			
			
		$output .= "	
		 <style>
		   div.clip {
			white-space: nowrap; /* Запрещаем перенос строк */
			overflow: hidden; /* Обрезаем все, что не помещается в область */
			text-overflow: ellipsis; /* Добавляем многоточие */
			max-width: 292px;
		   }
		  </style>
  ";
			
			$icon = t3lib_iconWorks::getSpriteIconForRecord('tx_air_elements', $damp, array());
			$output .= "<div class='dragelement_wrap' style='min-width: 200px; max-width: 350px; border: red 0px solid; ".$csspositionverdict." opacity: 1;'>
						
						<!--Данное поле является источником для передачи координат на обновление-->
						<input class='inputHiddenElementName' type='hidden' value='this.table.".$damp['key_element']."'>
						<input class='inputHiddenCoords' type='hidden' name='tx_infoblock_domain_model[update][coords][]' 
						value='this.table.".$damp['key_element']." = ".$coordsElements['this.']['table.'][$damp['key_element']].";'>
						
						<div style='cursor: move; float: right;' class='dragelement_move' >
							<div style='padding: 3px; border-radius: 8px 0 0 0; 
							background-color: gray; color: white; text-align: right; 
							width: auto; border: black 1px solid; white-space: nowrap;'>
							<div class='clip'><b>".$damp['uid']."] ".$damp['title']."</b></div></div>
						
						</div>
						<div style='clear: right;'></div>
						
						
						<div width='100%' border='3' cellspacing='0' bgcolor='#eeeeee' 
						style='min-width: 200px; border: black 1px solid; margin-top: -1px;'>
						
							<div style='background-color: #ece2bc; text-align: left; padding-left: 3px; padding-right: 3px;'>
								<div style='padding: 0px; line-height: 24px; white-space: nowrap;'>
								".$icon. " ".$damp['key_element']."
								</div>
							</div>
							<div style=' border-top: gray 1px solid; height: 5px; background-color: white; border-bottom: gray 1px solid;'></div>
							<div style='background-color: #ece2bc'>
								<div style='padding: 0px; border-bottom: gray 0px solid;'>
								<i>".nl2br($damp['service_note'])."</i></div>
							</div>
							
						".$output_columns.$output_temp."
						
						</div>
						
						<div style='padding: 3px; border-radius: 0 0 8px 8px; background-color: gray; width: auto; 
						border: black 1px solid;  border-top: 0;'></div>
					
					</div>";
		
		}
		return $output;
	
	}
	
		//Скрипт перевода размера файла из байтов в КБ, МБ
	function HumanBytes($size) {
		$filesizename = array(" Bytes", " Kb", " Mb", " Gb", " Tb", " Pb", " Eb", " Zb", " Yb");
		return $size ? round($size / pow(1024, ($i = floor(log($size, 1024)))), 2) . $filesizename[$i] : '0 Bytes';
	} 	
	
		//Функция наности на координаты на коробку
	function boxAadd_coords($damp_dmodel){
	
		return "
			<div style='position: absolute; opacity: 0.72; top: 10px; right: 10px; text-align: right;'>
			<!--
				x:<span id='boxArx_inform_x'>0</span> / y:<span id='boxArx_inform_y'>0</span><br />
				Событие: <span id='boxArx_inform_event'>-</span>
			-->	
			</div>
		";
		
	}
	
		
		// Список всех таблиц
	function getElements($parentElement = 0){

		// Считываем список всез накопителей...
		$res = $GLOBALS['TYPO3_DB']->sql_query('
		
			SELECT * FROM tx_air_elements WHERE 
			
			parent_element='.$parentElement.' AND
			type_element IN (
				"root-directory", 
				"new-infoblock-standart-default", 
				"new-infoblock-standart-settings",
				"new-infoblock-modification-pages",
				"new-infoblock-modification-tt_content",
				"new-infoblock-system",
				"domain-model",
				"new-add-columns"
			)

			ORDER BY type_element ASC,
					 key_element ASC,
					 title ASC						 
		
		');
		$num = $GLOBALS['TYPO3_DB']->sql_num_rows ( $res );
		if ($num == 0){
			//
		} else {
			
				##################################################
				// Читаем накопители...
				##################################################
				while($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res)) {
			
					// Если это дирректория модель:
					if ($row['type_element'] == "root-directory"){
						$content .= "<div class='elementTable' style='background: url(/typo3conf/ext/air_table/res/bg-fon-label-tab.png) left top; color: white;'>";
						//$content .= "<a href='/typo3/mod.php?M=tools_txtempM2&browseDomainModel=".$row['uid']."'>"; // beta
						$content .= t3lib_iconWorks::getSpriteIconForRecord('tx_air_elements', $row, array());
						$content .= "&nbsp;" . $row['title'];
						//$content .= "</a>"; // beta
						$content .= ":</div>";
						$content .= $this->getElements($row['uid']);
						
					// Если это доменная модель:
					} elseif ($row['type_element'] == "domain-model"){
						$content .= "<div class='elementTable'>";
						//$content .= "<a href='/typo3/mod.php?M=tools_txtempM2&browseDomainModel=".$row['uid']."'>"; // beta
						$content .= t3lib_iconWorks::getSpriteIconForRecord('tx_air_elements', $row, array());
						$content .= "&nbsp;" . $row['title'];
						
								// Вывод информации к месту где выводится путь к файлу где произведено описание
							if ($row['_system_value_path_ts_file_'] != null){
								$content .= " <a href='/".$row['_system_value_path_ts_file_']."' target='_blank'>
								<img style='vertical-align: top; opacity: 0.35;' src='/typo3conf/ext/air_table/res/ts.png'></a>";
							}
							
						//$content .= "</a>"; // beta
						
						$content .= "<div class='elementTableLevel_2'>";
						$content .= $this->getElements($row['uid']);
						$content .= "</div>";
						$content .= "</div>";
						
					// Если это добавление отдельных колонок
					} elseif ($row['type_element'] == "new-add-columns") {
						if ($row['key_element'] == null){
							$sql_key = "?";
						} else { 
							$sql_key = $row['key_element'];
						}
					
						$content .= "<div class='elementTable'>";
						$content .= "<a href='/typo3/mod.php?M=tools_txtempM2&browseTable=".$sql_key."'>";
						$content .= t3lib_iconWorks::getSpriteIconForRecord('tx_air_elements', $row, array());
						$content .= "<span class='plashka o6 green' style='float: none; background-color: black;'>".$sql_key."</span>";
						// $content .= "&nbsp;"; // . "[" . $row['uid'] . "] ";
						$content .= trim($row['title']);
						$content .= "</a>";
						
								// Вывод информации к месту где выводится путь к файлу где произведено описание
							if ($row['_system_value_path_ts_file_'] != null){
								$content .= " <a href='/".$row['_system_value_path_ts_file_']."' target='_blank'>
								<img style='vertical-align: top; opacity: 0.35;' src='/typo3conf/ext/air_table/res/ts.png'></a>";
							}
							
						//$content .= "</a>"; // beta
						//$content .= "<div class='elementTableLevel_2'>";
						//$content .= $this->getElements($row['uid']);
						//$content .= "</div>";
						
						$content .= $this->createTableOrColumn($row,1);
						$content .= "</div>";
						
					} else {
						
							// Проверка сущестования таблицы
						$resTable = $GLOBALS['TYPO3_DB']->sql_query("SELECT * FROM information_schema.tables WHERE TABLE_SCHEMA = '".TYPO3_db."' AND TABLE_NAME = '".$row['key_element']."' LIMIT 1");
						$numTable = $GLOBALS['TYPO3_DB']->sql_num_rows($resTable);
						
						if ($row['key_element'] == null){
							$sql_key = "?";
						} else { 
							$sql_key = $row['key_element'];
						}
						
						$content .= "<div class='elementTable'>";
						$content .= "<a href='/typo3/mod.php?M=tools_txtempM2&browseTable=".$sql_key."'>";
						$content .= t3lib_iconWorks::getSpriteIconForRecord('tx_air_elements', $row, array());
						$content .= "<span class='plashka o6 green' style='float: none; background-color: black;'>".$sql_key."</span>";
						// $content .= "&nbsp;"; // . "[" . $row['uid'] . "] ";
						$content .= trim($row['title']);
						$content .= "</a>";
						
								// Вывод информации к месту где выводится путь к файлу где произведено описание
							if ($row['_system_value_path_ts_file_'] != null){
								$content .= " <a href='/".$row['_system_value_path_ts_file_']."' target='_blank'>
								<img style='vertical-align: top; opacity: 0.35;' src='/typo3conf/ext/air_table/res/ts.png'></a>";
							}
							
							// Вывод деф. свойств
						if ($row['type_element'] == 'new-infoblock-standart-default'
						|| $row['type_element'] == 'new-infoblock-standart-settings') {
							
								// Ищем папку, где расположены деф. свойства
							$resDefPropertyFolderId = $GLOBALS['TYPO3_DB']->sql_query("
								SELECT uid FROM tx_air_elements WHERE 
								parent_element=".$row['uid']." AND
								type_element = 'folder'
								ORDER BY sorting ASC
								LIMIT 1;
							");
							$rowDefPropertyFolderId = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($resDefPropertyFolderId);
							$resDefProperty = $GLOBALS['TYPO3_DB']->sql_query("
								SELECT * FROM tx_air_elements
								WHERE parent_element = ".$rowDefPropertyFolderId['uid']."
								AND type_element = 'new-infoblock-property-def'
								ORDER BY key_element ASC
							");
							if ($GLOBALS['TYPO3_DB']->sql_num_rows($resDefProperty)) {
								$content .= "<span class='plashka o6 green DefPropertyShowOrHide' style='float: none; display: none; background-color: black;'>";
								$content .= " DefProperty: ";
								$DefProperty = null;
								while($rowDefProperty = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($resDefProperty)) {
									$DefProperty[] = $rowDefProperty['key_element'];
								}
								$content .= implode(", ", $DefProperty);
								$content .= "</span>";
							}
						}	
						
						
						$content .= $this->createTableOrColumn($row,$numTable);
						$content .= "</div>";
						
							
						##################################################
						// Считываем список все свойств накопителя...
						##################################################
						/* $resProperty = $GLOBALS['TYPO3_DB']->sql_query('SELECT * FROM tx_air_elements WHERE parent_element='.$row['uid'].' ORDER BY sorting ASC');
						$numProperty = $GLOBALS['TYPO3_DB']->sql_num_rows ( $resProperty );
						while($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($resProperty)) {
								
							$content .= "<div style='padding: 5px 6px 5px 6px; padding-left: 35px; cursor: pointer; border-left: black 3px solid;'>";
							$content .= t3lib_iconWorks::getSpriteIconForRecord('tx_air_elements', $row, array());
							$content .= "&nbsp;" . $row['title'];
							$content .= "</div>";
								
						} */
					}

				}
				
		}
		return $content;
	}
	
	function createTableOrColumn($row,$numTable) {
				if ($numTable > 0){
							
							// Кол-во записей
							$resRecordCount = $GLOBALS['TYPO3_DB']->sql_query("SELECT COUNT(*) AS 'countElement' FROM ".$row['key_element']."");
							$rowRecordCount = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($resRecordCount);
							
								#####################################################
								// Проверяем, все ли колонки подкрепленны таблицей? (start)
								####################################################
								
								$flag_Not_Column = 0;
								t3lib_div::loadTCA($row['key_element']);
								$columnsInTable = $GLOBALS['TCA'][$row['key_element']]['columns'];
								foreach ($columnsInTable as $key => $value){
									
									// Проверка сущестования колонки
									$resColumns = $GLOBALS['TYPO3_DB']->sql_query("
										SELECT * FROM information_schema.COLUMNS 
										WHERE 
											TABLE_SCHEMA='".TYPO3_db."'
												AND TABLE_NAME='".$row['key_element']."'
												AND COLUMN_NAME='".$key."'
									");
									$numColumns = $GLOBALS['TYPO3_DB']->sql_num_rows($resColumns);
									if ($numColumns <= 0){
										$flag_Not_Column = 1;
										break;
									}
									
								}	
								#####################################################
								// Проверяем, все ли колонки подкрепленны таблицей? (end)
								####################################################
							
							if ($flag_Not_Column == 1){
								$content .= "<span class='plashka o6 yellow link'><a href='/typo3/mod.php?M=tools_txtempM2&masterTable=1&elementTableKey=".$row['key_element']."'>Есть не подкрепленные колонки - исправить!</a></span>";
								$content .= "<span class='plashka o6'><b>".$rowRecordCount['countElement']."</b></span>";
							} else {
								$content .= "<span class='plashka o6 green'>Таблица подкреплена</span>";
								$content .= "<span class='plashka o6'><b>".$rowRecordCount['countElement']."</b></span>";
							}
							
						} else {
							// $content .= "<input style='float: right;' type='submit' value='создать'>";
							$content .= "<span class='plashka o6 red link'><a href='/typo3/mod.php?M=tools_txtempM2&masterTable=1&elementTableKey=".$row['key_element']."'>Таблица НЕ Существует - исправить!</a></span>";
						}
		
		return $content;
	}
	
}

		// Make instance:
		/** @var $SOBE tx_testtree_module1 */
		$SOBE = t3lib_div::makeInstance('tx_testtree_module1');
		$SOBE->init();

		// Include files?
		foreach ($SOBE->include_once as $INC_FILE) {
			include_once($INC_FILE);
		}

		$SOBE->main();
		$SOBE->printContent();


?>